#!/bin/sh
#Create a new pup_412pUPnGO.sfs
#This is a cut down and clean up of the build script 140310
#
#Move all non essencial stuff to zdrv.sfs
#Script name: build_pupngo_412.sh
#ENTIRELY FOR EXPERIMENTAL USE AND FUN...
XDIALOG_HIGH_DIALOG_COMPAT=1
export XDIALOG_HIGH_DIALOG_COMPAT
XDIALOG_INFOBOX_TIMEOUT=2000
export XDIALOG_INFOBOX_TIMEOUT

#VARIABELS
VERSION=${PUPPYVERSION}	
BUILD=`date --rfc-3339=date`	#Build date the only tag
BASEDIR=$(pwd)
DESTDIR=${BASEDIR}/data/P412_SFS/newsfs
#we might need a unique tag to the .sfs main file if not using a virtual machine during devellopment. Maybe Puppy during CD-boot plants the sfs file if "he" finds a place for it...
BUILDTYPE=REL	#DEV should give unique id, REL the usual naming...do not use...main sfs files will build up in /data/isomaster...

#build category, only one of below should be set=y
ALL=n	#build with all P412 drivers
HOST=n	#host machine, include all host drivers
USER=y	#build with user selected drivers only
#build media, only one of below should be set=y
CD=y 		#Create a CD-ISO as output
USB=n		#Build directly to chosen USB-drive

#choose if main sourcedir should be unpacked org. P412.sfs or current running P412:
USE_ORG_P412_SOURCE=y
if [ "${USE_ORG_P412_SOURCE}" = "y" ]; then
SOURCEDIR=${BASEDIR}/data/P412_SFS/unpacked
else
SOURCEDIR=/		#not tested throughly - increase final size.
fi 

USE_REDUCED=on	#y=build pupngo, n=build full size P412
USE_DHCPC=on	#add auto start network if present
USE_ZDRV=off	#if yes additional applications and drivers will be in zdrv otherwise in normal sfs
USE_WIZARDS=off	#use modified wizards from Puppy - use the wizards with caution
USE_GUI=on		#Include Xvesa (Kdrive) and JWM
BEAUTY_BOX=off	#If n only limited fonts - if y more fonts
USE_ENH_GUI=off	#glib, gtk stuff as basis for GUI applications...
USE_BB_INT=off	#A more intense use of BusyBox. Hacks of org. Puppy scripts - might break future additions
				#Used BusyBox-20100217
USE_ALSA=off	#Include sound (alsa-stuff)	

KERNEL_VER=$(uname -r)
KERNEL_MODULES=""
tempfile=/tmp/test.txt

if [ `which dialog` ]; then
DIALOG=dialog
[ -n "$DISPLAY" ] && [ `which Xdialog` ] && DIALOG="Xdialog"
USE_DIALOG=y
else
USE_DIALOG=n
fi

TITLE="BUILD pUPnGO_412"

#FUNCTIONS

################ DIALOG HELPERS ################
message() {
if [ "${USE_DIALOG}" = "y" ]; then
$DIALOG --title "$TITLE" "$2" "$1" 20 68
sleep 1
else
echo "$1"
fi
#clear
}

mode_select () {
if [ "${USE_DIALOG}" = "y" ]; then
$DIALOG --title "BUILD pUPnGO_412" --clear --yesno "Do you want to use the menu-driven build-system? If you manually have placed PETs in /data/pets-dir say no here - and edit build script to set build parameters." 0 0
case $? in
0)
USE_DIALOG=y;;
1)
USE_DIALOG=n
USE_REDUCED=y
USE_DHCPC=y
USE_ZDRV=n
USE_WIZARDS=n
USE_GUI=y
BEAUTY_BOX=n
USE_ENH_GUI=n
USE_BB_INT=n
USE_ALSA=n
;;	
255)
message "ESC pressed." "--msgbox";
exit;;
esac

fi	
}

add_pets () {
#we may delete all pets in /data/pets -dir...but what if user has added own pets?
rm -rf ${BASEDIR}/data/pets/*
$DIALOG --title "BUILD pUPnGO_412" --stdout --cr-wrap --checklist "pUPnGO build script has some limited ability to inject PET-archive in the build. Place PET file(s) in folder /data/pets and the script will try to include it/them. The below list is original packages for Puppy 4.XX and some custom made that can be included and normaly works. Choose below and the script will try to download and include in build." 0 0 0 "GEANY" "Geany text-editor. Original." off "GPARTED" "Gparted - disk tool. Original." off "LINKS" "Links text and graphical WEB-browser. Original." off "XFE" "Graphical File-manager. Custom" off "LYNX" "Lynx text WEB-browser. Custom." off "GXINE" "Gxine Media-player. Original" off "ABIWORD" "Abiword - word processor. Original" off "LAMP" "LAMP-Hiawatha-php-mysql. Custom" off > $tempfile

#retval=$?
#echo $retval
case $? in
   1)
    echo "No chosen.";
    exit;;
  255)
    echo "ESC pressed.";
    exit;;
  0)
INSTR=`cat $tempfile | grep -c "GEANY"`
if [ ! "$INSTR" = "0" ]; then
get_pet geany-0.16.pet ftp://distro.ibiblio.org/pub/linux/distributions/puppylinux/pet_packages-4/geany-0.16.pet
cp ${BASEDIR}/data/pet_repo/geany-0.16.pet ${BASEDIR}/data/pets/geany-0.16.pet
#automatic adjust CONFIGURE BUILD to cope with Geany
USE_GUI=y
USE_ENH_GUI=y
fi

INSTR=`cat $tempfile | grep -c "GPARTED"`
if [ ! "$INSTR" = "0" ]; then
get_pet gparted-0.3.3-patched1-staticgtkmm.pet ftp://distro.ibiblio.org/pub/linux/distributions/puppylinux/pet_packages-4/gparted-0.3.3-patched1-staticgtkmm.pet
cp ${BASEDIR}/data/pet_repo/gparted-0.3.3-patched1-staticgtkmm.pet ${BASEDIR}/data/pets/gparted-0.3.3-patched1-staticgtkmm.pet
#automatic adjust CONFIGURE BUILD to cope with Gparted
USE_GUI=y
USE_ENH_GUI=y
fi

INSTR=`cat $tempfile | grep -c "LINKS"`
if [ ! "$INSTR" = "0" ]; then
get_pet links-2.1pre30.pet ftp://distro.ibiblio.org/pub/linux/distributions/puppylinux/pet_packages-4/links-2.1pre30.pet
cp ${BASEDIR}/data/pet_repo/links-2.1pre30.pet ${BASEDIR}/data/pets/links-2.1pre30.pet
USE_GUI=y
USE_ENH_GUI=y
fi

INSTR=`cat $tempfile | grep -c "XFE"`
if [ ! "$INSTR" = "0" ]; then
get_pet xfe-1.19.2-i386.pet http://goingnuts.dk/userfiles/xfe-1.19.2-i386.pet
cp ${BASEDIR}/data/pet_repo/xfe-1.19.2-i386.pet ${BASEDIR}/data/pets/xfe-1.19.2-i386.pet
get_pet fox-1.6.25-libs.pet http://goingnuts.dk/userfiles/fox-1.6.25-libs.pet
cp ${BASEDIR}/data/pet_repo/fox-1.6.25-libs.pet ${BASEDIR}/data/pets/fox-1.6.25-libs.pet
USE_GUI=y
USE_ENH_GUI=y
fi

INSTR=`cat $tempfile | grep -c "LYNX"`
if [ ! "$INSTR" = "0" ]; then
get_pet lynx2-8-7-i486.pet http://goingnuts.dk/userfiles/lynx2-8-7-i486.pet
cp ${BASEDIR}/data/pet_repo/lynx2-8-7-i486.pet ${BASEDIR}/data/pets/lynx2-8-7-i486.pet
fi

INSTR=`cat $tempfile | grep -c "GXINE"`
if [ ! "$INSTR" = "0" ]; then 
#needs gxine-0.5.9-1.pet, xine-lib-1.1.8.pet
get_pet xine-lib-1.1.8.pet ftp://distro.ibiblio.org/pub/linux/distributions/puppylinux/pet_packages-4/xine-lib-1.1.8.pet
cp ${BASEDIR}/data/pet_repo/xine-lib-1.1.8.pet ${BASEDIR}/data/pets/xine-lib-1.1.8.pet
get_pet gxine-0.5.9-1.pet ftp://distro.ibiblio.org/pub/linux/distributions/puppylinux/pet_packages-4/gxine-0.5.9-1.pet
cp ${BASEDIR}/data/pet_repo/gxine-0.5.9-1.pet ${BASEDIR}/data/pets/gxine-0.5.9-1.pet
USE_GUI=y
USE_ENH_GUI=y
USE_ALSA=y
fi

INSTR=`cat $tempfile | grep -c "ABIWORD"`
if [ ! "$INSTR" = "0" ]; then
get_pet abiword-2.6.6-default.pet ftp://distro.ibiblio.org/pub/linux/distributions/puppylinux/pet_packages-4/abiword-2.6.6-default.pet
cp ${BASEDIR}/data/pet_repo/abiword-2.6.6-default.pet ${BASEDIR}/data/pets/abiword-2.6.6-default.pet
USE_GUI=y
USE_ENH_GUI=y
BEAUTY_BOX=y
fi

INSTR=`cat $tempfile | grep -c "LAMP"`
if [ ! "$INSTR" = "0" ]; then
get_pet LAMP-6.16-5.1.35-5.2.9.pet http://goingnuts.dk/userfiles/LAMP-6.16-5.1.35-5.2.9.pet
cp ${BASEDIR}/data/pet_repo/LAMP-6.16-5.1.35-5.2.9.pet ${BASEDIR}/data/pets/LAMP-6.16-5.1.35-5.2.9.pet
fi
  ;;
esac
	
}

get_pet () {
if [ ! -f ${BASEDIR}/data/pet_repo/$1 ]; then
wget -P ${BASEDIR}/data/pet_repo/ $2
fi

}

################ CATEGORY BUILD ################
drivers_select () {
#DRIVERS: ALL, HOST or USER

$DIALOG --title "BUILD pUPnGO_412" --stdout --cr-wrap --radiolist "Please choose a driver profile below.\nALL include all P412 drivers present. HOST include current loaded drivers on host.\nUSER include only user selected drivers (edit in build script)." 0 0 4 "ALL" "Build pUPnGO with all P412 drivers included." off "HOST" "Build pUPnGO with drivers surrently loaded by host." off "USER" "Build pUPnGO with user selected drivers only" on  > $tempfile

#echo $retval
case $? in
1)
echo "No chosen.";
exit;;
255)
echo "ESC pressed.";
exit;;
0)
INSTR=`cat $tempfile | grep -c "ALL"`
if [ ! "$INSTR" = "0" ]; then ALL=y; else ALL=n; fi

INSTR=`cat $tempfile | grep -c "HOST"`
if [ ! "$INSTR" = "0" ]; then HOST=y; else HOST=n; fi

INSTR=`cat $tempfile | grep -c "USER"`
if [ ! "$INSTR" = "0" ]; then USER=y; else USER=n; fi
;;
esac

#BUILD MEDIA
#CD or USB
$DIALOG --title "BUILD pUPnGO_412" --stdout --cr-wrap --radiolist "Please choose a build media below. The default is to create a bootable ISO image.\n" 0 0 3 "CD" "image will be created." off "USB" "image will be created." off > $tempfile

#echo $retval
case $? in
1)
echo "No chosen.";
exit;;
255)
echo "ESC pressed.";
exit;;
0)
INSTR=`cat $tempfile | grep -c "CD"`
if [ ! "$INSTR" = "0" ]; then CD=y; else CD=n; fi

INSTR=`cat $tempfile | grep -c "USB"`
if [ ! "$INSTR" = "0" ]; then USB=y; else USB=n; fi

;;
esac

}

################ MODULE CONFIGURE #############
module_finder () {
#echo "in start of module_finder"
#modified zdrvcutr - excelent script org. from technosaurous.
#target: offer to include host-drivers only or drivers from lsmod file and automatic list for further manuel choice. Maybe devided in groups of drivers?
#. /etc/DISTRO_SPECS #gets $DISTRO* variables
#KERNELVER=$(uname -r) # get the version of your kernel
#PREFIX1CHAR="`echo -n "$DISTRO_FILE_PREFIX" | cut -c 1`"
#KERNEL3CHARS="`echo -n "$KERNELVER" | tr -d '.' | tr -d '\-' | tr -d '[a-z]' | rev | cut -c 1,2,3 | rev`"
ZDIR="zPUPNGO_DRVS"
# set this to the name of a temp dir:
TMPDIR=/dev/shm/$ZDIR #faster to use /dev/shm
# create the module directory in the TMP dir:

mkdir -p $TMPDIR

lsmod |tail +2 |cut -f1 -d' ' > $TMPDIR/mods #just a list of modules

sed -i "s/_/?/g" $TMPDIR/mods #replaces the _ with ? so that - and . will not give false evaluation

echo >$TMPDIR/fw

for module in $(cat $TMPDIR/mods) ; do
#hardcoded from /etc/modules/firmware.dep - maybe better to have this dynamic?
case $module in
#analog modem drivers...
agrserial) echo agrsm >>$TMPDIR/fw;;
cdc-acm) echo cdcacm >>$TMPDIR/fw;;
dgcusbdcp) echo dgcmodem >>$TMPDIR/fw;;
esscom) echo ess >>$TMPDIR/fw;;
Intel536) echo intel536ep >>$TMPDIR/fw;;
intel537EP) echo intel537ep >>$TMPDIR/fw;;
ltmodem) echo ltmodem >>$TMPDIR/fw;;
martian_dev) echo martian >>$TMPDIR/fw;;
mwave) echo mwavem >>$TMPDIR/fw;;
pctel) echo pctel >>$TMPDIR/fw;;
pl2303) echo pl2303 >>$TMPDIR/fw;;
slamr|slusb|snd-via82xx-modem|snd-atiixp-modem|snd-intel8x0m|snd-hda-intel) echo slmodem >>$TMPDIR/fw;;

#wireless networking drivers...
acx)echo acx_firmware >>$TMPDIR/fw;;
acx?mac80211)echo acx_firmware >>$TMPDIR/fw;;
atmel_pci|atmel_cs|at76_usb) echo atmel_fw>>$TMPDIR/fw;;
b43) echo b43 >>$TMPDIR/fw;;
b43legacy) echo b43legacy >>$TMPDIR/fw;;
hostap|hostap_pci|hostap_plx|hostap_cs) echo hostap >>$TMPDIR/fw;;
iwl3945|iwl4965|iwlagn) echo iwlwifi >>$TMPDIR/fw;;
ipw2100) echo ipw2100_firmware >>$TMPDIR/fw;;
ipw2200) echo ipw2200_firmware >>$TMPDIR/fw;;
libertas_cs|libertas_sdio|usb8xxx) echo libertas_firmware >>$TMPDIR/fw;;
prism2_usb) echo linux-wlan-ng >>$TMPDIR/fw;;
ath_pci) echo madwifi >>$TMPDIR/fw;;
ti_usb_3410_5052) echo pgprs >>$TMPDIR/fw;;
prism54|p54pci|p54usb) echo prism54_firmware >>$TMPDIR/fw;;
rt2860sta) echo rt2860sta-fw >>$TMPDIR/fw;;
rt2870sta) echo rt2870sta-fw >>$TMPDIR/fw;;
rt2x00pci|rt2x00usb|rt61pci|rt73usb|rt2400pci|rt2500pci|rt2500usb) echo rt2x00 >>$TMPDIR/fw;;
zd1201) echo zd1201_firmware >>$TMPDIR/fw;;
zd1211rw) echo zd1211_firmware >>$TMPDIR/fw;;

#media drivers...
qcmessenger) echo qc-usb-messenger >>$TMPDIR/fw;;
dvb-usb-a800|dvb-usb-af9005|dvb-usb-au6610|dvb-usb-cxusb|dvb-usb-dib0700|dvb-usb-dibusb-mb|dvb-usb-dibusb-mc|dvb-usb-digitv|dvb-usb-dtt200u|dvb-usb-gl861|dvb-usb-gp8psk|dvb-usb-m920x|dvb-usb-nova-t-usb2|dvb-usb-opera|dvb-usb-ttusb2|dvb-usb-umt-010|dvb-usb-vp702x|dvb-usb-vp7045) echo dvb-usb-firmware >>$TMPDIR/fw;;
	
##############BELOW NOT IN P412##########
#ar9170usb) echo ar9170usb >>$TMPDIR/fw;;
#hcfpcihw) echo hcfpcimodem >>$TMPDIR/fw;;
#hsfhda|hsfmc97ali|hsfmc97ati|hsfmc97ich|hsfmc97sis|hsfmc97via|hsfpcibasic2|hsfpcibasic3|hsfusbcd2) echo hsfmodem >>$TMPDIR/fw;;
#hso) echo hso >>$TMPDIR/fw;;
#ipw) echo ipw >>$TMPDIR/fw;;
#ipwireless) echo ipwireless >>$TMPDIR/fw;;
#libertas_tf_usb) echo libertas_tf >>$TMPDIR/fw;;
#moto_modem) echo motomodem >>$TMPDIR/fw;;
#mwl8k) echo mwl8k >>$TMPDIR/fw;;
#nozomi) echo nozomi >>$TMPDIR/fw;;
#option) echo option >>$TMPDIR/fw;;
#sierra) echo sierra >>$TMPDIR/fw;;
				
#*) echo "No firmware required for kernel module: "$module
esac
done

cd /

for module in $(cat $TMPDIR/mods) ; do
#uncomment the first and comment the second one to just see the list
#find lib/modules/$KVERS -type f -name "$module*"
find lib/modules/$KERNELVER -type f -name "$module*" -exec cp --parents {} $TMPDIR/ \;
done

for firmware in $(cat $TMPDIR/fw) ; do
# uncomment the first and comment the second one to just see the list
# find lib/modules/$KVERS -type f -name "$module*"
find lib/modules/all-firmware -type f -name "$firmware*" -exec cp --parents {} $TMPDIR/ \;
done
sync

rm -rf $TMPDIR/lib/modules/$KERNEL_VER/initrd
#guess above is all pupngo needs. 
#mv all to build environment mising code

cp -a /dev/shm/$ZDIR/lib/ $1/

#cleanup
rm $TMPDIR/mods
rm $TMPDIR/fw
rm -rf $TMPDIR
sync
}

################ CONFIGURE BUILD ###############
configure_build () {
sync

if [ "${USE_DIALOG}" = "y" ]; then
$DIALOG --title "BUILD pUPnGO_412" --stdout --clear --checklist "This buildscript has several ways to build pUPnGO - depending on what you are planning to use pUPnGO for. Below is the present opportunities listed." 0 0 0 "USE_REDUCED" "Chosen build pUPnGO else build full size P412" ${USE_REDUCED} "USE_DHCPC" "Add auto start network if present" ${USE_DHCPC} "USE_ZDRV" "Additional applications and drivers in zdrv" ${USE_ZDRV} "USE_WIZARDS" "Use modified wizards from Puppy" ${USE_WIZARDS} "USE_GUI" "Include Xvesa (Kdrive) and JWM" ${USE_GUI} "BEAUTY_BOX" "If not chosen only limited fonts in GUI" ${BEAUTY_BOX} "USE_ENH_GUI" "glib, gtk stuff as basis for GUI applications..." ${USE_ENH_GUI} "USE_BB_INT" "A more intense use of BusyBox." ${USE_BB_INT} "USE_ALSA" "Include sound (alsa-stuff)" off > $tempfile

case $? in
   1)
    message "Cancel chosen - exiting." "--msgbox";
    exit;;
  255)
    message "ESC pressed  - exiting." "--msgbox";
    exit;;
  0)
INSTR=`cat $tempfile | grep -c "USE_REDUCED"`
if [ ! "$INSTR" = "0" ]; then USE_REDUCED=y; else USE_REDUCED=n; fi

INSTR=`cat $tempfile | grep -c "USE_DHCPC"`
if [ ! "$INSTR" = "0" ]; then USE_DHCPC=y; else USE_DHCPC=n; fi

INSTR=`cat $tempfile | grep -c "USE_ZDRV"`
if [ ! "$INSTR" = "0" ]; then USE_ZDRV=y; else USE_ZDRV=n; fi

INSTR=`cat $tempfile | grep -c "USE_WIZARDS"`
if [ ! "$INSTR" = "0" ]; then USE_WIZARDS=y; else USE_WIZARDS=n; fi

INSTR=`cat $tempfile | grep -c "USE_GUI"`
if [ ! "$INSTR" = "0" ]; then USE_GUI=y; else USE_GUI=n; fi

INSTR=`cat $tempfile | grep -c "BEAUTY_BOX"`
if [ ! "$INSTR" = "0" ]; then BEAUTY_BOX=y; else BEAUTY_BOX=n; fi

INSTR=`cat $tempfile | grep -c "USE_ENH_GUI"`
if [ ! "$INSTR" = "0" ]; then USE_ENH_GUI=y; else USE_ENH_GUI=n; fi

INSTR=`cat $tempfile | grep -c "USE_BB_INT"`
if [ ! "$INSTR" = "0" ]; then USE_BB_INT=y; else USE_BB_INT=n; fi

INSTR=`cat $tempfile | grep -c "USE_ALSA"`
if [ ! "$INSTR" = "0" ]; then USE_ALSA=y; else USE_ALSA=n; fi

  ;;
esac

else
echo
echo "You can change the build options by editing the build script...Using default options for this build..."
echo
fi

}

################ CHECK ENVIRONMENT #############
check_environment() {
#check host version
if [ -f /etc/puppyversion ]; then
PUPPYVERSION=`cat /etc/puppyversion`
if [ ! "$PUPPYVERSION" = "412" ]; then
#echo "This script is only valid running Puppy Linux 412 - aborting..."
message "This script is only valid running Puppy Linux 412 - aborting..." "--msgbox"
exit
fi
fi

#check presense of crucial sources
#/home/puppy412/vmlinuz
#/home/puppy412/pup_412.sfs
#/home/puppy412/initrd.gz
if [ ! -f /mnt/home/puppy412/pup_412.sfs ]; then
#echo "You need the file /mnt/home/puppy412/pup_412.sfs - normaly present on a Frugal install with a personal save-file...aborting..."
message "You need the file /mnt/home/puppy412/pup_412.sfs - normaly present on a Frugal install with a personal save-file...aborting..." "--msgbox"
exit
fi

if [ ! -f /mnt/home/puppy412/vmlinuz ]; then
#echo "You need the file /mnt/home/puppy412/vmlinuz - aborting..."
message "You need the file /mnt/home/puppy412/vmlinuz - aborting..." "--msgbox"
exit
fi

if [ ! -f /mnt/home/puppy412/initrd.gz ]; then
#echo "You need the file /mnt/home/puppy412/initrd.gz - aborting..."
message "You need the file /mnt/home/puppy412/initrd.gz - aborting..." "--msgbox"
exit
fi

#check presense of "ar"
if [ ! `which ar` ]; then
#echo "You need ar installed - get it here: http://goingnuts.dk/userfiles/ar.pet - aborting..."
message "You need ar installed - get it here: http://goingnuts.dk/userfiles/ar.pet - aborting..." "--msgbox"
exit
fi

#check presense of "qemu"
if [ ! `which qemu` ]; then
#echo "You should install qemu to run your builds - get it here: http://goingnuts.dk/userfiles/qemu-0.91-launchscript-SDL-1.29.pet - aborting..."
message "You should install qemu to run your builds - get it here: http://goingnuts.dk/userfiles/qemu-0.91-launchscript-SDL-1.29.pet - aborting..." "--msgbox"
exit
fi
}

################ ADD PROGRAM ###################
add_program() {
#copies a program and the libraries it needs to the target add_program <source> [<dest>]if dest is not given the source is copied to the same place on the destination system
PROGRAM=$1
if [ "$2" == "" ];then
TARGET=$1
else
TARGET=$2
fi

cp -f ${PROGRAM} ${DESTDIR}/${TARGET}

for LIB in $(ldd ${PROGRAM} | grep "=>" | cut -d ' ' -f 3); do
#below prints out size of program and needed lib - comment out if not needed.
#echo `du -h ${PROGRAM}` " - " `du -h -L ${LIB}`

mkdir -p $(dirname ${DESTDIR}/${LIB})
if [ ! -f ${DESTDIR}/${LIB} ]; then	#do not add twice...
cp -f ${LIB} ${DESTDIR}/${LIB}
fi
done

sync
}

################ DHCP Client ###################
add_dhcpc() {
#adds dhcp client (to be simplified)
DESTDIR=$1
#echo "Adding DHCP client..."
message "Adding DHCP Client..." "--infobox"
#DHCP client script
mkdir -p ${DESTDIR}/etc/init.d
mkdir -p ${DESTDIR}/etc/rcS.d
cat >${DESTDIR}/etc/init.d/udhcpc <<EOF
#!/bin/sh
# /etc/init.d/udhcpc: start or stop udhcpc client
set -e
PATH=/bin:/usr/bin:/sbin:/usr/sbin
DAEMON=/sbin/udhcpc

test -x \${DAEMON} || exit 0

case "\$1" in
  start)
   echo -n "Starting DHCP client: udhcpc" 
   echo
   \${DAEMON} &
  ;;
esac
exit 0
EOF
chmod a+x ${DESTDIR}/etc/init.d/udhcpc

ln -s ../init.d/udhcpc ${DESTDIR}/etc/rcS.d/S40udhcpc

#default dhcpc script executed when there is a change in status
mkdir -p ${DESTDIR}/usr/share/udhcpc
cat >${DESTDIR}/usr/share/udhcpc/default.script <<EOF
#!/bin/sh
/bin/run-parts --arg=\$1 /etc/udhcpc.d &
EOF

chmod a+x ${DESTDIR}/usr/share/udhcpc/default.script

mkdir -p ${DESTDIR}/etc/udhcpc.d
#below must be converted to script (function)
#cp ${BASEDIR}/udhcp_default ${DESTDIR}/etc/udhcpc.d/S50default
create_udhpc_default

#main rcS script
cat >${DESTDIR}/etc/init.d/rcS <<EOF
/bin/run-parts --arg=start /etc/rcS.d
EOF
chmod a+x ${DESTDIR}/etc/init.d/rcS
}

################ Kernel modules required #######
add_kernel_modules() {
DESTDIR=$1
if [ "x${KERNEL_VER}" = "x" ]; then
KERNEL_VER=$(uname -r)
fi
	
for MODULE in ${KERNEL_MODULES}; do
mkdir -p ${DESTDIR}/lib/modules/${KERNEL_VER}/$(dirname ${MODULE})
cp /lib/modules/${KERNEL_VER}/${MODULE} ${DESTDIR}/lib/modules/${KERNEL_VER}/${MODULE}
done

cp /lib/modules/${KERNEL_VER}/modules.alias ${DESTDIR}/lib/modules/${KERNEL_VER}/
cp /lib/modules/${KERNEL_VER}/modules.dep ${DESTDIR}/lib/modules/${KERNEL_VER}/

#This might not be needed...
mkdir -p ${DESTDIR}/etc/rcS.d/
echo "#!/bin/sh" >${DESTDIR}/etc/rcS.d/S20modules  
for MODULE in ${KERNEL_MODULES}; do
echo "/sbin/modprobe" $(basename ${MODULE} .ko) >> ${DESTDIR}/etc/rcS.d/S20modules
done
chmod a+x ${DESTDIR}/etc/rcS.d/S20modules

sync
}

################ Create udhcp_default ##########
create_udhpc_default() {
#${DESTDIR}/etc/udhcpc.d/S50default
cat >${DESTDIR}/etc/udhcpc.d/S50default <<EOF
#!/bin/sh
PATH=/bin:/usr/bin:/sbin:/usr/sbin
RESOLV_CONF="/etc/resolv.conf"
update_interface() {
[ -n "\$broadcast" ] && BROADCAST="broadcast \$broadcast"
[ -n "\$subnet" ] && NETMASK="netmask \$subnet"
/sbin/ifconfig \$interface \$ip \$BROADCAST \$NETMASK
}

update_routes() {
if [ -n "\$router" ]; then
echo "deleting routes"
while /sbin/route del default gw 0.0.0.0 dev \$interface
do :
done
for i in \$router
do
/sbin/route add default gw \$i dev \$interface
done
fi
}

update_dns() {
echo -n > \$RESOLV_CONF
[ -n "\$domain" ] && echo domain \$domain >> \$RESOLV_CONF
for i in \$dns
do
echo adding dns \$i
echo nameserver \$i >> \$RESOLV_CONF
done
}

deconfig() {
/sbin/ifconfig \$interface 0.0.0.0
}

case "\$1" in
bound)
update_interface;
update_routes;
update_dns;
;;

renew)
update_interface;
update_routes;
update_dns;
;;

deconfig)
deconfig;
;;

*)
echo "Usage: \$0 {bound|renew|deconfig}"
exit 1
;;
esac
exit 0
EOF
chmod a+x ${DESTDIR}/etc/udhcpc.d/S50default
}

################ Clean Build Environment #######
clean_build_area() {
if [ -d $DESTDIR ];then rm -r $DESTDIR; fi
mkdir -p $DESTDIR
}

################ Create Build Environment ######
create_build_env(){
#create build environment if not already present. We need build directories... 
for d in data/tools/busybox data/doc data/isomaster/doc data/P412_initrd/build data/P412_initrd/packed data/P412_initrd/unpacked data/P412_SFS/build data/P412_SFS/newsfs data/P412_SFS/packed data/P412_SFS/unpacked data/pets data/ZDRV output qemu; do
if [ ! -d ${BASEDIR}/${d} ]; then
mkdir -p ${BASEDIR}/${d}
fi
done
sync

if [ ! -f ${BASEDIR}/qemu/create_disk.sh ];then
cat >${BASEDIR}/qemu/create_disk.sh <<EOF
#!/bin/sh
qemu-img create test.img 60M &
EOF
chmod a+x ${BASEDIR}/qemu/create_disk.sh
fi

if [ ! -f ${BASEDIR}/qemu_cd_boot.sh ];then
cat >${BASEDIR}/qemu_cd_boot.sh <<EOF
#!/bin/sh
qemu -m 128 -boot d -hda qemu/test.img -cdrom output/output.iso -usb -no-kqemu -net nic -net user -redir tcp:5555:10.0.2.15:80 -soundhw sb16 &
EOF
chmod a+x ${BASEDIR}/qemu_cd_boot.sh
fi

#create qemu disk
#echo "Creating qemu hd-image..."
message "Creating qemu hd-image..." "--infobox"

cd ${BASEDIR}/qemu
./create_disk.sh
cd ${BASEDIR}

if [ ! -f ${BASEDIR}/data/isomaster/isolinux.bin ];then
#echo "You must manually provide isolinux.bin to be present in the isomaster directory. Get it from the original Puppy Linux CD or from the pUPnGO.ISO (http://goingnuts.dk/userfiles/pUPnGO_V412.iso)"
message "You must manually provide isolinux.bin to be present in the isomaster directory. Get it from the original Puppy Linux CD or from the pUPnGO.ISO (http://goingnuts.dk/userfiles/pUPnGO_V412.iso)" "--msgbox"
exit
fi

if [ ! -f ${BASEDIR}/data/tools/busybox/busybox ];then
#echo "You must manually provide busybox to be present in the data/tools/busybox directory. Get it from the pUPnGO.ISO"
message "You must manually provide busybox to be present in the data/tools/busybox directory. Get it from the pUPnGO.ISO" "--msgbox"
exit
fi

#get the sources in place
if [ ! -f ${BASEDIR}/data/P412_SFS/packed/temp_pup_412.sfs ]; then
cp /mnt/home/puppy412/pup_412.sfs ${BASEDIR}/data/P412_SFS/packed/temp_pup_412.sfs
fi

#unpack it in ${BASEDIR}/data/P412_SFS/unpacked/
if [ ! "$(ls -A ${BASEDIR}/data/P412_SFS/unpacked/)" ]; then
#echo "Unpacking and copying original pup_412.sfs"
message "Unpacking and Copying Original pup_412.sfs" "--infobox"
#mount and copy content to unpacked
rm -rf /tmp/temp_sfs
mkdir /tmp/temp_sfs
mount ${BASEDIR}/data/P412_SFS/packed/temp_pup_412.sfs /tmp/temp_sfs/ -t squashfs -o loop
cp -a /tmp/temp_sfs/* ${BASEDIR}/data/P412_SFS/unpacked/
umount /tmp/temp_sfs/
#clean up
#rm ${BASEDIR}/data/P412_SFS/packed/temp_pup_412.sfs
fi

if [ ! -f ${BASEDIR}/data/isomaster/vmlinuz ];then
cp /mnt/home/puppy412/vmlinuz ${BASEDIR}/data/isomaster/vmlinuz
fi
if [ ! -f ${BASEDIR}/data/isomaster/initrd.gz ];then
cp /mnt/home/puppy412/initrd.gz ${BASEDIR}/data/isomaster/initrd.gz
cp /mnt/home/puppy412/initrd.gz ${BASEDIR}/data/P412_initrd/packed/initrd.gz
fi
}

################ Build original P412 ###########
build_full_size() {
#echo "Building full size P412..."
message "Building Full Size P412..." "--infobox"
cp -a ${SOURCEDIR}/archive/ ${DESTDIR}/
cp -a ${SOURCEDIR}/bin/ ${DESTDIR}/
cp -a ${SOURCEDIR}/dev/ ${DESTDIR}/
cp -a ${SOURCEDIR}/etc/ ${DESTDIR}/
cp -a ${SOURCEDIR}/lib/ ${DESTDIR}/
cp -a ${SOURCEDIR}/mnt/ ${DESTDIR}/
cp -a ${SOURCEDIR}/opt/ ${DESTDIR}/
cp -a ${SOURCEDIR}/proc/ ${DESTDIR}/
cp -a ${SOURCEDIR}/root/ ${DESTDIR}/
cp -a ${SOURCEDIR}/sbin/ ${DESTDIR}/
cp -a ${SOURCEDIR}/tmp/ ${DESTDIR}/
cp -a ${SOURCEDIR}/usr/ ${DESTDIR}/
cp -a ${SOURCEDIR}/var/ ${DESTDIR}/
if [ "${USE_ZDRV}" = "y" ]; then
#place /lib/firmware, modules and network in zdrv_412.sfs
mkdir -p /tmp/pet/zdrv_412/lib
mv ${DESTDIR}/lib/firmware/ /tmp/pet/zdrv_412/lib/
mv ${DESTDIR}/lib/modules/ /tmp/pet/zdrv_412/lib/
mv ${DESTDIR}/lib/network/ /tmp/pet/zdrv_412/lib/

#dir converted to sfs....
dir2sfs /tmp/pet/zdrv_412/
#copy new zdrv_412.sfs to $BASEDIR/data/ZDRV
if [ -f $BASEDIR/data/ZDRV/zdrv_412.sfs ]; then
rm $BASEDIR/data/ZDRV/zdrv_412.sfs
fi
mv /tmp/pet/zdrv_412.sfs $BASEDIR/data/ZDRV/zdrv_412.sfs
rm -r /tmp/pet/zdrv_412
#end use_zdrv=y
fi
}

################ Create pUPnGO /etc/profile ####
create_etc_profile() {
#echo "Creating New /etc/profile..."
message "Creating New /etc/profile..." "--infobox"
cat >${DESTDIR}/etc/profile <<EOF
PATH="/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/usr/sbin:/usr/X11R6/bin"
LD_LIBRARY_PATH="/lib:/usr/lib:/usr/X11R7/lib:/root/my-applications/lib:/usr/lib/seamonkey"
export PATH LD_LIBRARY_PATH
ulimit -c 0
if [ `id -gn` = `id -un` -a `id -u` -gt 14 ]; then
umask 002
else
umask 022
fi
USER=`id -un`
PS1="# "
LOGNAME=$USER
HISTSIZE=1000
HISTFILE="$HOME/.history"
INPUTRC=/etc/inputrc
export PS1 USER LOGNAME HISTSIZE INPUTRC
LANG=en_US
export LANG
TZ="`readlink /etc/localtime | sed -e 's%/usr/share/zoneinfo/%%'`" #v3.02
export TZ
HOSTNAME="`cat /etc/hostname | tr -d "\n"`"
export HOSTNAME
SHELL="/bin/ash"
export SHELL
export G_FILENAME_ENCODING=@locale
if [ -d /opt/mozilla.org ];then
 [ -d /opt/mozilla.org/lib ] && LD_LIBRARY_PATH="$LD_LIBRARY_PATH:/opt/mozilla.org/lib"
 [ -d /opt/mozilla.org/bin ] && PATH="$PATH:/opt/mozilla.org/bin" #may not exist.
 [ -d /opt/mozilla.org/lib/pkgconfig ] && PKG_CONFIG_PATH="$PKG_CONFIG_PATH:/opt/mozilla.org/lib/pkgconfig"
 [ -e /opt/mozilla.org/lib/mozilla ] && export MOZILLA_FIVE_HOME="/opt/mozilla.org/lib/mozilla" #link created unleashed.
fi
/bin/chmod 777 /tmp
EOF
#tagging....
if [ "${USE_GUI}" = "n" ]; then
GREETING="Welcome to pUPnGO_V"$VERSION"_Build"$BUILD
else
GREETING="Welcome to pUPnGO_V"$VERSION"_Build"$BUILD" - Type startx to start JWM..."
fi
echo "echo -e \"${GREETING}"\" >> ${DESTDIR}/etc/profile

}

################ Create pUPnGO rc.local ########
create_rc_local() {
#this part reformulated - moved this functionality to time of shutdown - ask user if it is ok - implement technosaurous zdrvcutter as an opportunity.	

#old code	
#cat >${DESTDIR}/etc/rc.d/rc.local <<EOF
#!/bin/sh
#special script for pUPnGO to merge zdrv_412.sfs content with personal save file. In short: Whenever there are files in /initrd/pup_z after boot a potential personal save (and in P412 original loss of content in zdrv_412.sfs) - the content of /initrd/pup_z are copied to running /.
#date >> /tmp/pupngo.txt

#FILECOUNT=\`ls /initrd/pup_z | wc -l\`
#echo  \$FILECOUNT " files in /initrd/pup_z..." >> /tmp/pupngo.txt
#if [ ! \$FILECOUNT = "0" ]; then	
#echo -n "pUPnGO copying files from zdrv..." >/dev/console
#So copy all content from /initrd/pup_z to / 
#echo "copying files from /initrd/pup_z to /..."  >> /tmp/pupngo.txt
#cp -a /initrd/pup_z/* /
#sync
#/bin/echo -e "\\\\033[72G\\\\033[1;32mdone\\\\033[0;39m" >/dev/console #green [done] msg.
#fi

#EOF
#chmod a+x ${DESTDIR}/etc/rc.d/rc.local

###########NEW CODE#############

#hack /sbin/poweroff
mv ${DESTDIR}/sbin/poweroff ${DESTDIR}/sbin/poweroff.old
sed 's#\#\!/bin/sh#\#\!/bin/sh\n/sbin/pupngo_zdrv#g' ${DESTDIR}/sbin/poweroff.old > ${DESTDIR}/sbin/poweroff
rm -f ${DESTDIR}/sbin/poweroff.old
chmod a+x ${DESTDIR}/sbin/poweroff

cat >${DESTDIR}/sbin/pupngo_zdrv <<EOF
#!/bin/sh
#special script for pUPnGO to merge zdrv_412.sfs content with personal save file. In short: Whenever there are files in /initrd/pup_z after boot a potential personal save (and in P412 original loss of content in zdrv_412.sfs) - the content of /initrd/pup_z are copied to running /.
XDIALOG_HIGH_DIALOG_COMPAT=1
export XDIALOG_HIGH_DIALOG_COMPAT

if [ \`which dialog\` ]; then
DIALOG=dialog
[ -n "\$DISPLAY" ] && [ \`which Xdialog\` ] && DIALOG="Xdialog"
fi
TITLE="pUPnGO Shutdown Script"
FILECOUNT=\`ls /initrd/pup_z | wc -l\`
echo  \$FILECOUNT " files in /initrd/pup_z..." 
cutterdialog () {
\$DIALOG --title "\$TITLE" --yesno "You have chosen to copy content from zdrv to temp-file of running pUPnGO before poweroff. You can additionally cut down on driver-content present in zdrv. This means that only driver needed will be left in the save-file. Note: This script do not check if you have space enough to do this operation. Choose Yes below to cut down on drivers - choose No to copy all zdrv-content to running temp-file - and continue to normal Puppy poweroff." 0 0	
case \$? in
1)
echo "No chosen - continue with copy zdrv.";
;;
255)
echo "ESC pressed - continue to normal poweroff";
exit;;
0)
echo "Yes chosen.";
zdrvcutr;
;;
esac
}
zdrvcutr () {
#modified zdrvcutr - excelent script org. from technosaurous.
#target: offer to include host-drivers only or drivers from lsmod file and automatic list for further manuel choice. Maybe devided in groups of drivers?
KERNEL_VER=\$(uname -r) # get the version of your kernel
ZDIR="zPUPNGO_DRVS"
#set this to the name of a temp dir:
TMPDIR=/dev/shm/\$ZDIR #faster to use /dev/shm
# create the module directory in the TMP dir:
mkdir -p \$TMPDIR
echo "Profilling - please wait..."
lsmod |tail +2 |cut -f1 -d' ' > \$TMPDIR/mods #just a list of modules
sed -i "s/_/?/g" \$TMPDIR/mods #replaces the _ with ? so that - and . will not give false evaluation
echo >\$TMPDIR/fw
for module in \$(cat \$TMPDIR/mods) ; do
#hardcoded from /etc/modules/firmware.dep - maybe better to have this dynamic?
case \$module in
#analog modem drivers...
agrserial) echo agrsm >>\$TMPDIR/fw;;
cdc-acm) echo cdcacm >>\$TMPDIR/fw;;
dgcusbdcp) echo dgcmodem >>\$TMPDIR/fw;;
esscom) echo ess >>\$TMPDIR/fw;;
Intel536) echo intel536ep >>\$TMPDIR/fw;;
intel537EP) echo intel537ep >>\$TMPDIR/fw;;
ltmodem) echo ltmodem >>\$TMPDIR/fw;;
martian_dev) echo martian >>\$TMPDIR/fw;;
mwave) echo mwavem >>\$TMPDIR/fw;;
pctel) echo pctel >>\$TMPDIR/fw;;
pl2303) echo pl2303 >>\$TMPDIR/fw;;
slamr|slusb|snd-via82xx-modem|snd-atiixp-modem|snd-intel8x0m|snd-hda-intel) echo slmodem >>\$TMPDIR/fw;;
#wireless networking drivers...
acx)echo acx_firmware >>\$TMPDIR/fw;;
acx?mac80211)echo acx_firmware >>\$TMPDIR/fw;;
atmel_pci|atmel_cs|at76_usb) echo atmel_fw>>\$TMPDIR/fw;;
b43) echo b43 >>\$TMPDIR/fw;;
b43legacy) echo b43legacy >>\$TMPDIR/fw;;
hostap|hostap_pci|hostap_plx|hostap_cs) echo hostap >>\$TMPDIR/fw;;
iwl3945|iwl4965|iwlagn) echo iwlwifi >>\$TMPDIR/fw;;
ipw2100) echo ipw2100_firmware >>\$TMPDIR/fw;;
ipw2200) echo ipw2200_firmware >>\$TMPDIR/fw;;
libertas_cs|libertas_sdio|usb8xxx) echo libertas_firmware >>\$TMPDIR/fw;;
prism2_usb) echo linux-wlan-ng >>\$TMPDIR/fw;;
ath_pci) echo madwifi >>\$TMPDIR/fw;;
ti_usb_3410_5052) echo pgprs >>\$TMPDIR/fw;;
prism54|p54pci|p54usb) echo prism54_firmware >>\$TMPDIR/fw;;
rt2860sta) echo rt2860sta-fw >>\$TMPDIR/fw;;
rt2870sta) echo rt2870sta-fw >>\$TMPDIR/fw;;
rt2x00pci|rt2x00usb|rt61pci|rt73usb|rt2400pci|rt2500pci|rt2500usb) echo rt2x00 >>\$TMPDIR/fw;;
zd1201) echo zd1201_firmware >>\$TMPDIR/fw;;
zd1211rw) echo zd1211_firmware >>\$TMPDIR/fw;;
#media drivers...
qcmessenger) echo qc-usb-messenger >>\$TMPDIR/fw;;
dvb-usb-a800|dvb-usb-af9005|dvb-usb-au6610|dvb-usb-cxusb|dvb-usb-dib0700|dvb-usb-dibusb-mb|dvb-usb-dibusb-mc|dvb-usb-digitv|dvb-usb-dtt200u|dvb-usb-gl861|dvb-usb-gp8psk|dvb-usb-m920x|dvb-usb-nova-t-usb2|dvb-usb-opera|dvb-usb-ttusb2|dvb-usb-umt-010|dvb-usb-vp702x|dvb-usb-vp7045) echo dvb-usb-firmware >>\$TMPDIR/fw;;
esac
done
cd /
for module in \$(cat \$TMPDIR/mods) ; do
#uncomment the first and comment the second one to just see the list
#find lib/modules/\$KVERS -type f -name "\$module*"
find lib/modules/\$KERNELVER -type f -name "\$module*" -exec cp --parents {} \$TMPDIR/ \;
done
for firmware in \$(cat \$TMPDIR/fw) ; do
#uncomment the first and comment the second one to just see the list
#find lib/modules/\$KVERS -type f -name "\$module*"
find lib/modules/all-firmware -type f -name "\$firmware*" -exec cp --parents {} \$TMPDIR/ \;
done
sync
rm -rf \$TMPDIR/lib/modules/\$KERNEL_VER/initrd
rm \$TMPDIR/mods #cleanup
rm \$TMPDIR/fw #cleanup
#alternative route: just copy \$TMPDIR/lib/ to root
cp -a \$TMPDIR/lib/ /
#cleanup
rm -rf \$TMPDIR
#copy rest in zdrv to /
cd /initrd/pup_z/
ls > /tmp/zdvrdirs
for dir in \$(cat /tmp/zdvrdirs) ; do
if [ ! "\${dir}" = "lib" ]; then
cp -a /initrd/pup_z/\${dir} /
fi
done
#if files in zdrv/lib 
cd /initrd/pup_z/lib/
ls > /tmp/zdvrfiles
for file in \$(cat /tmp/zdvrfiles) ; do
if [ ! "\${file}" = "firmware" ]; then
if [ ! "\${file}" = "modules" ]; then
if [ ! "\${file}" = "network" ]; then
cp -a /initrd/pup_z/lib/\${file} /lib/
fi
fi
fi
done

sync
echo "All done..."
#finalised
exit
}
zdrvcopy () {
echo -n "pUPnGO copying files from zdrv..."
cp -a /initrd/pup_z/* /
sync
}
if [ ! \$FILECOUNT = "0" ]; then
\$DIALOG --title "\$TITLE" --yesno "You seem to be booting from CD and are currently using zdrv. If you are going to create a personal savefile at shutdown, your content in zdrv will be lost, when pUPnGO copies the main pup_412PUPNGO.sfs file to hard drive. To preserve the content of zdrv, pUPnGO can copy the content to the running temp-file system. After save and reboot zdrv_412.sfs can be deleted. Press Yes to do this -  or No to skip -  and continue to normal Puppy poweroff." 0 0
case \$? in
1)
echo "No chosen.";
exit;;
255)
echo "ESC pressed.";
exit;;
0)
echo "Yes chosen.";
#offer to run zdrvcutter
cutterdialog
#copy zdrv
zdrvcopy
exit;;
esac

fi

#exit	#for debug
EOF
chmod a+x ${DESTDIR}/sbin/pupngo_zdrv

}

################ Add BusyBox and Link ##########
add_busybox_and_link() {
#echo "Adding New Dynamic Busybox and Linking..."
message "Adding New Dynamic Busybox and Linking..." "--infobox"
#copy in new dynamic BusyBox
cp ${BASEDIR}/data/tools/busybox/busybox ${DESTDIR}/bin/busybox
#BusyBox symlinks
chroot ${DESTDIR} /bin/busybox --install -s
sync
}

################ Create Basic Directory Layout #
create_directory_layout() {
#echo "Building new pup_412.sfs directory layout..."
message "Building New pup_412.sfs Directory Layout..." "--infobox"
#create P412 directory layout
for d in archive bin etc lib mnt opt root sbin tmp usr var /proc/sys/net/ipv4 /proc/self/fd /etc/init.d; do
mkdir -p ${DESTDIR}/${d}
done

cd ${DESTDIR}/proc/self/fd
ln -s /dev/pts/0 0
ln -s /dev/pts/0 1
ln -s /dev/pts/0 2
ln -s /dev/pts/0 255
cd $BASEDIR

cp -a ${SOURCEDIR}/dev/ ${DESTDIR}/

#/mnt related
for d in cdrom data dvd flash floppy msdos ram1 swap zip; do
mkdir -p ${DESTDIR}/mnt/${d}
done

#/var related
for d in var/lock var/log var/run var/tmp; do
mkdir -p ${DESTDIR}/${d}
done

#/usr related
for d in bin etc lib local sbin share X11R7; do
mkdir -p ${DESTDIR}/usr/${d}
done
}

################ Add Modified Wizards ##########
add_wizards() {
#Grub setup
#echo "Adding Grub..."
message "Adding Grub..." "--infobox"
cp /usr/sbin/grub* ${DESTDIR}/usr/sbin/
cp -a /usr/lib/grub/ ${DESTDIR}/usr/lib/
cp -f ${SOURCEDIR}/bin/cp-FULL ${DESTDIR}/bin/cp-FULL
cp -f ${SOURCEDIR}/bin/cp ${DESTDIR}/bin/cp
add_program /usr/sbin/grub
#dialog modified grubconfig:
cp ${BASEDIR}/data/tools/grub/new_grubconfig ${DESTDIR}/usr/sbin/grubconfig
for f in fdisk probedisk2; do
cp -af ${SOURCEDIR}/sbin/${f} ${DESTDIR}/sbin/
done

#new-bootmanager
#echo "Adding Bootmanager..."
message "Adding Bootmanager..." "--infobox"
cp ${BASEDIR}/data/tools/bootmanager/new_bootmanager ${DESTDIR}/usr/sbin/bootmanager
}

################ Add Xvesa and JWM #############
add_xvesa_jwm() {
#Download Kdrive binary from [http://www.pps.jussieu.fr/~jch/software/kdrive/xvesa_0.20031107-2_all.deb]
if [ ! -f /root/my-documents/xvesa_0.20031107-2_all.deb ]; then
wget -P /root/my-documents/ http://www.pps.jussieu.fr/~jch/software/kdrive/xvesa_0.20031107-2_all.deb
fi
mkdir -p ${DESTDIR}/root
mkdir -p ${DESTDIR}/usr/bin
mkdir -p ${DESTDIR}/etc
mkdir -p ${DESTDIR}/usr/share/fonts/default/TTF
chmod 777 ${DESTDIR}/usr/share/fonts
chmod 777 ${DESTDIR}/usr/share/fonts/default
chmod 777 ${DESTDIR}/usr/share/fonts/default/TTF
#echo "Adding Xvesa and JWM..."
message "Adding Xvesa and JWM..." "--infobox"
#Unpack kdrive
mkdir /tmp/unpack
cd /tmp/unpack
ar -x /root/my-documents/xvesa_0.20031107-2_all.deb
tar -xf data.tar.gz
cp -a /tmp/unpack/usr/X11R6/bin/ ${DESTDIR}/usr/X11R7/

#Xvesa from Kdrive is not stripped as downloaded - if strip present lets save some bytes
if [ `which strip` ]; then
#echo "Stripping Xvesa..."
strip ${DESTDIR}/usr/X11R6/bin/Xvesa
fi

add_program /tmp/unpack/usr/X11R6/bin/Xvesa /usr/X11R7/bin/Xvesa

#startx for Kdrive
#create file startx
cat >${DESTDIR}/usr/X11R7/bin/startx <<EOF
#!/bin/sh
export DISPLAY=:0.0
export FONTCONFIG_PATH=/etc/fonts
#Xvesa section
/usr/X11R7/bin/Xvesa -shadow -screen 800x600x256 -mouse /dev/psaux,5 2> /tmp/xerrs.log > /dev/null &
/usr/X11R7/bin/jwm 2>> /tmp/xerrs.log > /dev/null &
EOF

chmod a+x ${DESTDIR}/usr/X11R7/bin/startx

#create symlink X to Xvesa
cd ${DESTDIR}/usr/X11R7/bin/
ln -s Xvesa X
cd ${BASEDIR}

#add the needed programs and their dependencies
cp /usr/bin/rxvt ${DESTDIR}/usr/bin/rxvt

#JWM Part - we take original from running host Puppy Linux P412...
add_program /usr/X11R7/bin/jwm

if [ "${BEAUTY_BOX}" = "n" ]; then
#only minimal fonts needed to start jwm - we do not need a beauty-box...
cp /usr/X11R7/lib/X11/fonts/misc/7x14-ISO8859-1.pcf ${DESTDIR}/usr/share/fonts/default/TTF/7x14-ISO8859-1.pcf

#and the /etc/fonts/ stuff
cp -a /etc/fonts/ ${DESTDIR}/etc/fonts/

#create fonts.dir and fonts.scale
mkfontscale ${DESTDIR}/usr/share/fonts/default/TTF/
mkfontdir ${DESTDIR}/usr/share/fonts/default/TTF/
fc-cache ${DESTDIR}/usr/share/fonts/default/TTF/

# Create New Minimal /root/.jwmrc
cat >${DESTDIR}/root/.jwmrc <<EOF
<?xml version="1.0"?>
<JWM>
<!-- The root menu, if this is undefined you will not get a menu. -->
<!-- Additional RootMenu attributes: onroot, labeled, label -->
<RootMenu label="Menu" labeled="true" label="pUPnGO-V412" height="24" onroot="3">
<Separator/>
<Menu label="System" height="16">
<Program label="Top view running processes">rxvt -e /usr/bin/top</Program>
</Menu>
<Program label="Terminal">rxvt</Program>
<Separator/>
<Menu label="Shutdown" height="16">
<Restart label="Restart JWM"/>
<Program label="Exit to prompt">killall Xvesa</Program>
</Menu>
</RootMenu>

<!-- Additional tray attributes: autohide, width, border, layer, layout -->
<Tray autohide="false" insert="right" x="0" y="-1" border="1" height="28" >

<!-- Additional TrayButton attribute: label -->
<TrayButton label="Menu">root:3</TrayButton>

<!-- TrayButton popup="Run commandline">exec:gexec</TrayButton> -->
<TrayButton popup="Show Desktop" label="_">showdesktop</TrayButton>

<!-- Additional Pager attributes; width, height -->
<Pager/>

<!-- Additional TaskList attribute: maxwidth -->
<TaskList/>

<Dock/>

<!-- Additional Swallow attribute: height -->
<!-- <Swallow name="xload" width="32">xload -nolabel -bg "#888888" -fg black -hl white</Swallow> -->

<Clock format="%H:%M"></Clock>
</Tray>

<!-- Visual Styles -->
<WindowStyle>
<Font antialias="false">smoothansi</Font>
<Width>4</Width>
<Height>20</Height>
<Active>
<Text>#3B3B3B</Text>
<Title>#AFC79E:#EBEED5</Title>
<Corner>white</Corner>
<Outline>grey22</Outline>
</Active>
<Inactive>
<Text>#3B3B3B</Text>
<Title>#AFC79E:gray70</Title>
<Corner>grey33</Corner>
<Outline>black</Outline>
</Inactive>
</WindowStyle>

<TaskListStyle>
<Font antialias="false">smoothansi</Font>
<ActiveForeground>#3B3B3B</ActiveForeground>
<ActiveBackground>#AFC79E:#EBEED5</ActiveBackground>
<Foreground>#3B3B3B</Foreground>
<Background>#AFC79E:gray70</Background>
</TaskListStyle>

<!-- Additional TrayStyle attribute: insert -->
<TrayStyle>
<Font antialias="false">smoothansi</Font>
<Background>#AFC79E</Background>
<Foreground>#3B3B3B</Foreground>
</TrayStyle>

<PagerStyle>
<Outline>darkred</Outline>
<Foreground>grey44</Foreground>
<Background>grey22</Background>
<ActiveForeground>grey55</ActiveForeground>
<ActiveBackground>grey66</ActiveBackground>
</PagerStyle>

<MenuStyle>
<Font antialias="false">smoothansi</Font>
<Foreground>#3B3B3B</Foreground>
<Background>#AFC79E</Background>
<ActiveForeground>#3B3B3B</ActiveForeground>
<ActiveBackground>#AFC79E:#EBEED5</ActiveBackground>
</MenuStyle>

<PopupStyle>
<Font antialias="false">smoothansi</Font>
<Outline>darkred</Outline>
<Foreground>black</Foreground>
<Background>grey66</Background>
</PopupStyle>

<!-- Virtual Desktops -->
<!-- Desktop tags can be contained within Desktops for desktop names. -->
<Desktops count="2">
<Desktop Name="One"> 
<Background type="solid">#5984B1</Background>
</Desktop>
<Desktop Name="Two"> 
<Background type="solid">#5984B1</Background>
</Desktop>
</Desktops>


<!-- Double click speed (in milliseconds) -->
<DoubleClickSpeed>400</DoubleClickSpeed>

<!-- Double click delta (in pixels) -->
<DoubleClickDelta>3</DoubleClickDelta>

<!-- The focus model (sloppy or click) -->
<!-- <FocusModel>sloppy</FocusModel> -->
<FocusModel>click</FocusModel>

<!-- The snap mode (none, screen, or border) -->
<SnapMode distance="10">border</SnapMode>

<!-- The move mode (outline or opaque) -->
<MoveMode>opaque</MoveMode>

<!-- The resize mode (outline or opaque) -->
<ResizeMode>opaque</ResizeMode>

<!-- Key bindings -->
<Key key="Up">up</Key>
<Key key="Down">down</Key>
<Key key="Right">right</Key>
<Key key="Left">left</Key>
<Key key="h">left</Key>
<Key key="j">down</Key>
<Key key="k">up</Key>
<Key key="l">right</Key>
<Key key="Return">select</Key>
<Key key="Escape">escape</Key>

<Key mask="A" key="Tab">next</Key>
<Key mask="A" key="F4">close</Key>
<Key mask="A" key="#">desktop#</Key>
<Key mask="A" key="F1">root:3</Key>
<Key mask="A" key="F2">window</Key>
</JWM>
EOF
fi

if [ "${BEAUTY_BOX}" = "y" ]; then
cp -a /usr/share/backgrounds/default.jpg ${DESTDIR}/root/default.jpg
cp -a ${SOURCEDIR}/usr/X11R7/lib/xserver/ ${DESTDIR}/usr/X11R7/lib/
cp -a ${SOURCEDIR}/usr/share/fonts/ ${DESTDIR}/usr/share/
mkdir -p ${DESTDIR}/usr/X11R7/lib/X11/fonts/
cp -a ${SOURCEDIR}/usr/X11R7/lib/X11/fonts/ ${DESTDIR}/usr/X11R7/lib/X11/

#only a reduced amount of fonts
#cp /usr/share/fonts/default/TTF/DejaVuSans-BoldOblique.ttf ${DESTDIR}/usr/share/fonts/default/TTF/DejaVuSans-BoldOblique.ttf

#cp /usr/share/fonts/default/TTF/DejaVuSans-Bold.ttf ${DESTDIR}/usr/share/fonts/default/TTF/DejaVuSans-Bold.ttf

#cp /usr/share/fonts/default/TTF/DejaVuSans-Oblique.ttf ${DESTDIR}/usr/share/fonts/default/TTF/DejaVuSans-Oblique.ttf

#cp /usr/share/fonts/default/TTF/DejaVuSans.ttf ${DESTDIR}/usr/share/fonts/default/TTF/DejaVuSans.ttf

#and the /etc/fonts/ stuff
cp -a /etc/fonts/ ${DESTDIR}/etc/fonts/

#create fonts.dir and fonts.scale
#mkfontscale ${DESTDIR}/usr/share/fonts/default/TTF/
#mkfontdir ${DESTDIR}/usr/share/fonts/default/TTF/
#fc-cache ${DESTDIR}/usr/share/fonts/default/TTF/

# Create New Minimal /root/.jwmrc
cat >${DESTDIR}/root/.jwmrc <<EOF
<?xml version="1.0"?>
<JWM>
<!-- The root menu, if this is undefined you will not get a menu. -->
<!-- Additional RootMenu attributes: onroot, labeled, label -->
<RootMenu label="Menu" labeled="true" label="pUPnGO-V412" height="24" onroot="3">
<Separator/>
<Menu label="System" height="16">
<Program label="Top view running processes">rxvt -e /usr/bin/top</Program>
</Menu>
<Program label="Terminal">rxvt</Program>
<Separator/>
<Menu label="Shutdown" height="16">
<Restart label="Restart JWM"/>
<Program label="Exit to prompt">killall Xvesa</Program>
</Menu>
</RootMenu>

<Group>
<Name>rxvt</Name>
<Option>vmax</Option>
</Group>

<!-- Additional tray attributes: autohide, width, border, layer, layout -->
<Tray  autohide="false" insert="right" x="0" y="-1" border="1" height="28" >

<!-- Additional TrayButton attribute: label -->
<TrayButton label="Menu">root:3</TrayButton>

<!--	<TrayButton popup="Run commandline">exec:gexec</TrayButton> -->
<TrayButton popup="Show Desktop" label="_">showdesktop</TrayButton>
		

<!-- Additional Pager attributes; width, height -->
<Pager/>

<!-- Additional TaskList attribute: maxwidth -->
<TaskList/>

<Dock/>

<!-- Additional Swallow attribute: height -->
<Swallow name="xload" width="32">
xload -nolabel -bg "#888888" -fg red -hl white
</Swallow>>

		
<Clock format="%H:%M"></Clock>
</Tray>

<!-- Visual Styles -->
<WindowStyle>
<Font>DejaVu Sans-12</Font>
<Width>3</Width>
<Height>22</Height>
<Active>
<Text>white</Text>
<Title>grey33:grey66</Title>
<Corner>white</Corner>
<Outline>grey22</Outline>
</Active>
<Inactive>
<Text>grey44</Text>
<Title>grey22:black</Title>
<Corner>grey33</Corner>
<Outline>black</Outline>
</Inactive>
</WindowStyle>

<TaskListStyle>
<Font>DejaVu Sans-12</Font>
<ActiveForeground>white</ActiveForeground>
<ActiveBackground>grey33:grey66</ActiveBackground>
<Foreground>grey44</Foreground>
<Background>grey22:black</Background>
</TaskListStyle>

<PagerStyle>
<Outline>darkred</Outline>
<Foreground>grey44</Foreground>
<Background>grey22</Background>
<ActiveForeground>grey55</ActiveForeground>
<ActiveBackground>grey66</ActiveBackground>
</PagerStyle>

<MenuStyle>
<Font>DejaVu Sans-12</Font>
<Foreground>black</Foreground>
<Background>#c5c9cd</Background>
<ActiveForeground>black</ActiveForeground>
<ActiveBackground>#c5c9cd:#645f53</ActiveBackground>
</MenuStyle>

<PopupStyle>
<Font>DejaVu Sans-12</Font>
<Outline>black</Outline>
<Foreground>black</Foreground>
<Background>gray</Background>
</PopupStyle>

<!-- Virtual Desktops -->
<!-- Desktop tags can be contained within Desktops for desktop names. -->
<Desktops count="2">

<!-- Default background. Note that a Background tag can be
contained within a Desktop tag to give a specific background
for that desktop.
-->
<!-- <Background type="tile">/root/default.jpg</Background>  -->
<!-- <Background type="solid">gray</Background>  -->
<Background type="gradient">black:gray44</Background>
</Desktops>

<!-- Double click speed (in milliseconds) -->
<DoubleClickSpeed>400</DoubleClickSpeed>

<!-- Double click delta (in pixels) -->
<DoubleClickDelta>3</DoubleClickDelta>

<!-- The focus model (sloppy or click) -->
<FocusModel>sloppy</FocusModel>

<!-- The snap mode (none, screen, or border) -->
<SnapMode distance="10">border</SnapMode>

<!-- The move mode (outline or opaque) -->
<MoveMode>opaque</MoveMode>

<!-- The resize mode (outline or opaque) -->
<ResizeMode>opaque</ResizeMode>

<!-- Key bindings -->
<Key key="Up">up</Key>
<Key key="Down">down</Key>
<Key key="Right">right</Key>
<Key key="Left">left</Key>
<Key key="h">left</Key>
<Key key="j">down</Key>
<Key key="k">up</Key>
<Key key="l">right</Key>
<Key key="Return">select</Key>
<Key key="Escape">escape</Key>

<Key mask="A" key="Tab">next</Key>
<Key mask="A" key="F4">close</Key>
<Key mask="A" key="#">desktop#</Key>
<Key mask="A" key="F1">root:3</Key>
<Key mask="A" key="F2">window</Key>
</JWM>
EOF


fi
}

################ Add Enhanced GUI basics########
add_enh_gui () {
#echo "Adding GUI enhanced basics..."
message "Adding GUI Enhanced Basics..." "--infobox"
add_program /usr/bin/iconv
add_program /usr/bin/locale
mkdir -p ${DESTDIR}/usr/lib/pango/1.6.0
mkdir -p ${DESTDIR}/etc/pango
cp -a ${SOURCEDIR}/etc/pango/ ${DESTDIR}/etc/
cp -a ${SOURCEDIR}/usr/lib/pango/1.6.0/modules/ ${DESTDIR}/usr/lib/pango/1.6.0/
cp -a ${SOURCEDIR}/usr/lib/libxml2.so.2.6.30 ${DESTDIR}/usr/lib/libxml2.so.2.6.30
cp -a ${SOURCEDIR}/usr/lib/locale/ ${DESTDIR}/usr/lib/ #from glibc_i18n_en-2.5.pet
cp -a ${SOURCEDIR}/usr/lib/gconv/ ${DESTDIR}/usr/lib/
cp -a ${SOURCEDIR}/usr/lib/librsvg-2.so.2.18.2 ${DESTDIR}/usr/lib/librsvg-2.so.2.18.2
cp -a ${SOURCEDIR}/usr/lib/librsvg-2.so.2 ${DESTDIR}/usr/lib/librsvg-2.so.2
cp -a ${SOURCEDIR}/usr/lib/libxml2.so.2.6.30 ${DESTDIR}/usr/lib/libxml2.so.2.6.30
get_pet glib-2.14.2.pet
cp ${BASEDIR}/data/pet_repo/glib-2.14.2.pet ${BASEDIR}/data/pets/glib-2.14.2.pet
get_pet gtk+-2.12.1.pet
cp ${BASEDIR}/data/pet_repo/gtk+-2.12.1.pet ${BASEDIR}/data/pets/gtk+-2.12.1.pet

}

################ Add Alsa ######################
add_alsa () {
#add_program /usr/bin/fuser #moved to main for cd-save to work
add_program /bin/gawk
cp -a ${SOURCEDIR}/bin/awk ${DESTDIR}/bin/awk
add_program /sbin/modinfo
add_program /sbin/lspci
cp -a ${SOURCEDIR}/sbin/modinfo.bin ${DESTDIR}/sbin/modinfo.bin

#from alsa-lib-1.0.16.pet
add_program /usr/bin/aserver
cp -a ${SOURCEDIR}/usr/lib/alsa-lib/ ${DESTDIR}/usr/lib/
cp -a ${SOURCEDIR}/usr/lib/libasound.so.2.0.0 ${DESTDIR}/usr/lib/libasound.so.2.0.0
cp -a ${SOURCEDIR}/usr/lib/libasound.so.2 ${DESTDIR}/usr/lib/libasound.so.2
cp -a ${SOURCEDIR}/usr/share/alsa/ ${DESTDIR}/usr/share/
#from alsa-utils-1.0.16.pet
add_program /usr/bin/aconnect
add_program /usr/bin/alsamixer	
add_program /usr/bin/amidi
add_program /usr/bin/amixer
add_program /usr/bin/aplay
add_program /usr/bin/aplaymidi
cp -a ${SOURCEDIR}/usr/bin/arecord ${DESTDIR}/usr/bin/arecord
add_program /usr/bin/arecordmidi
add_program /usr/bin/aseqdump
add_program /usr/bin/aseqnet
add_program /usr/bin/iecset
add_program /usr/bin/speaker-test
add_program /usr/sbin/alsactl
#to here

add_program /usr/sbin/alsaconf
add_program /usr/sbin/alsawizard

#from gettext.pet
add_program /usr/bin/gettext
cp -a ${SOURCEDIR}/usr/lib/preloadable_libintl.so ${DESTDIR}/usr/lib/preloadable_libintl.so
#to here

mkdir -p ${DESTDIR}/var/lock/subsys
cp -a ${SOURCEDIR}/etc/modprobe.conf ${DESTDIR}/etc/modprobe.conf
mkdir -p ${DESTDIR}/usr/share/audio
cp -a ${SOURCEDIR}/usr/share/audio/ ${DESTDIR}/usr/share/
cp -a ${SOURCEDIR}/usr/share/i18n/ ${DESTDIR}/usr/share/

mkdir -p ${DESTDIR}/lib/modules/2.6.25.16/kernel/sound/
cp -a ${SOURCEDIR}/lib/modules/2.6.25.16/kernel/sound/ ${DESTDIR}/lib/modules/2.6.25.16/kernel/
mkdir -p ${DESTDIR}/lib/modules/2.6.25.16/kernel/drivers/input/
cp -a ${SOURCEDIR}/lib/modules/2.6.25.16/kernel/drivers/input/ ${DESTDIR}/lib/modules/2.6.25.16/kernel/drivers/

#Avoid bash - hack rc.alsa...this is ok - but alsaconf uses arrays not supported by busybox-ash.
#no reason to do this unless alsaconf severe re-written...
#for f in ${DESTDIR}/etc/rc.d/rc.alsa
#do mv $f $f.old
#sed 's#\/bin\/bash#\/bin\/sh#g' $f.old > $f
#rm -f $f.old
#mv $f $f.old
#sed 's#function ##g' $f.old > $f
#rm -f $f.old
#chmod a+x $f
#done
add_program /bin/bash
}

################ Main Build Program Start ######
#function call
message "Welcome to pUPnGO build script." "--msgbox"
#function call
mode_select		#menu or not = slow or swift...?

#function call
check_environment
#function call
clean_build_area
#function call
create_build_env
#function call
if [ "${USE_DIALOG}" = "y" ]; then
drivers_select		#sets PROFILE and DEVELLOP(default)
fi

#function call
configure_build

#For menu-build offer to place additional pets in /data/pets
if [ "${USE_DIALOG}" = "y" ]; then
add_pets #function call
fi

if [ "${USE_REDUCED}" = "n" ]; then	#rebuild full-size P412
#function call
build_full_size
fi

if [ "${USE_REDUCED}" = "y" ]; then	#build pupngo
#Create essential files - build new main P412 SFS-file
create_directory_layout	#function call


#/etc related
cp -a ${SOURCEDIR}/etc/rc.d/ ${DESTDIR}/etc/
cp -a ${SOURCEDIR}/etc/udev/ ${DESTDIR}/etc/
cp -a ${SOURCEDIR}/etc/network-wizard/ ${DESTDIR}/etc/

for f in fstab hosts hostname mime.types resolv.conf inittab localtime modprobe.conf puppyversion services protocols inputrc host.conf hosts.allow hosts.deny; do
cp -a ${SOURCEDIR}/etc/${f} ${DESTDIR}/etc/${f}
done

#setup networks for loopback - content differs from org P412 
echo -e "loopback 127.0.0.0\nlocalnet 0.0.0.0" > ${DESTDIR}/etc/networks

#users: maybe a choice if original or running Puppy files to be used
#echo "Adding Local Users..."
message "Adding Local Users..." "--infobox"
cp /etc/passwd ${DESTDIR}/etc/passwd
cp /etc/group ${DESTDIR}/etc/group
cp /etc/shadow ${DESTDIR}/etc/shadow

#create new /etc/profile - content differs from org P412 
create_etc_profile	#function call

cd ${DESTDIR}/usr/
ln -sf X11R7 X11R6 #symbolic link to X11R6
cd $BASEDIR

cp -a ${SOURCEDIR}/usr/lib/udev/ ${DESTDIR}/usr/lib/
cp -a ${SOURCEDIR}/usr/share/kbd/ ${DESTDIR}/usr/share/
cp -a ${SOURCEDIR}/usr/share/terminfo/ ${DESTDIR}/usr/share/
cp -a ${SOURCEDIR}/usr/share/zoneinfo/ ${DESTDIR}/usr/share/
cp -a ${SOURCEDIR}/usr/share/locale/ ${DESTDIR}/usr/share/

cp ${SOURCEDIR}/usr/sbin/wag-profiles.sh ${DESTDIR}/usr/sbin/ #functions used by rc.network - so needed at startup.

cp -a ${SOURCEDIR}/usr/sbin/snapmergepuppy ${DESTDIR}/usr/sbin/


cp -a ${SOURCEDIR}/usr/sbin/disktype ${DESTDIR}/usr/sbin/


#Add DHCP client if required
if [ "${USE_DHCPC}" = "y" ]; then
add_dhcpc ${DESTDIR}	#function call
fi

#Add Extra libs
EXTRA_LIBS="ld-linux.so.2 libm.so.6 libc.so.6 libnss_dns.so.2 libnss_files.so.2 libproc-3.2.7.so"
for LIB in ${EXTRA_LIBS}; do
if [ ! -f ${DESTDIR}/${LIB} ]; then
cp -f /lib/${LIB} ${DESTDIR}/lib/${LIB}
fi
done
#always missed - but not mentioned....
cp -a /usr/lib/libgcc_s.so.1 ${DESTDIR}/usr/lib/libgcc_s.so.1
EXTRA_LIBS=""


#BusyBox inclusion - determin if this is done before or after adding Puppy org. files. Before makes all BusyBox build-in programs present and Puppy org. file will be writen over them. After BusyBox respect already present files and do not overwrite. If you later plan to rewrite some of Puppy org. scripts that needs Puppy org. files to use BusyBox (reduce complexity and size) the first approach seems optimal. BB is build with most things activated - another way is to build without the files org. Puppy needs. Your choice.
#function call
add_busybox_and_link	


#bugs: save cd missing /usr/bin/growisosf
add_program /usr/bin/growisofs
#used in:
#/usr/sbin/burniso2cd
#/usr/sbin/pdvdrsab
#/usr/sbin/remasterpup2
#/usr/local/pbackup/func
#/usr/local/pbackup/pbackup
#/usr/local/pburnfunc
#/usr/local/pburnfunc_build_command

if [ "${USE_BB_INT}" = "y"  ]; then
#/bin related
#df script inactivated: cp -f ${SOURCEDIR}/bin/df ${DESTDIR}/bin/df
cp -f ${SOURCEDIR}/bin/ps ${DESTDIR}/bin/ps		#puppy spec. script

#deactivated mount -> seems OK
#cp -f ${SOURCEDIR}/bin/mount ${DESTDIR}/bin/mount

#cp-FULL 44K (link to cp) inactivated - mainly used in org. Puppy for GRUB-things (cp-FULL -p)
#cp -f ${SOURCEDIR}/bin/cp-FULL ${DESTDIR}/bin/cp-FULL

#below contain:
#pup_event_backend_d used in rc.sysinit
#pup_event_frontend_d used in snapmergepuppy
#puppyinputdetect used in rc.sysinit
#pup_event_backend_firmware used in 50-udev-puppy-basic.rules
#pup_event_frontend_d-OLD1	NOT used in pUPnGO
#puppyserialdetect referred in rc.sysinit but NOT used in pUPnGO
#pup_event_backend_modprobe used in 50-udev-puppy-basic.rules
#pup_event_load_module 	NOT used in pUPnGO

for f in pup_event_backend_d pup_event_frontend_d puppyinputdetect pup_event_backend_firmware pup_event_backend_modprobe; do
cp -f ${SOURCEDIR}/sbin/${f} ${DESTDIR}/sbin/
done

add_program /usr/bin/dialog		#/lib/libncurses.so.5 /lib/libm.so.6
add_program /usr/bin/fuser		#needed for cd.save
add_program /usr/bin/eject		#needed for cd.save 
add_program /usr/bin/wodim		#needed for cd.save
cp -a ${SOURCEDIR}/usr/bin/cdrecord ${DESTDIR}/usr/bin/cdrecord #needed for cd.save symlink to wodim
add_program /usr/bin/dvd+rw-mediainfo	#needed for cd.save

#ps-FULL 55K needs /lib/libproc-3.2.7.so 40K
#mount-FULL 48K needs /lib/libblkid.so.1 28K and /lib/libuuid.so.1 8192B
#dd 32K needs /lib/librt.so.1 31K and /lib/libpthread.so.0 74K

#ps-FULL 55K	NOT used in pUPnGO but ps -H -A (process hierarchy/All proceses) and ps -e (All proceses) used in rc.shutdown
#ps h used in rc.d/functions - ps ax and ps -e and ps -eo in wag-profiles
#mount in pUPnGO: functions4puppy mount -t /-o
#deactivate below and poweroff fails to save.
#deactivate mount-FULL 
for f in ps-FULL dd; do
add_program /bin/${f}
done

#programs only using /lib/libc.so.6
#BB reduction 15K: cat -> seems OK
#BB reduction 12K : sleep -> seems OK
#BB reduction 44K: cp -> seems OK
#BB reduction 75K: sed -> seems OK
#BB reduction 0K: df -> seems OK (use in shutdown: df -k and df -m)
#BB reduction 31K: df-FULL -> seems OK	(Seems only to be present in pup-script df...)
#BB reduction 103K: find -> fails in snapmergepuppy
#BB reduction: stat -> failure at poweroff wrong diskspace calculated - fixed below...
#stat used in rc.shutdown/snapmergepuppy/pup_event_backend_d
#I THINK IT IS "--format=" that needs to be removed...BUT: FOR SAVING 27K?
#debug stat in rc.shutdown - modified rc.shutdown stat -> BB-version
#cp -f ${BASEDIR}/data/tools/BB_hacks/rc.shutdown ${DESTDIR}/etc/rc.d/rc.shutdown
#BB reduction: stat ->	OK
#yes - hack the files - it is intensive BB use we aim at:
for f in ${DESTDIR}/etc/rc.d/rc.shutdown ${DESTDIR}/usr/sbin/snapmergepuppy ${DESTDIR}/sbin/pup_event_backend_d
do mv $f $f.old
sed 's#stat --format=#stat -c #g' $f.old > $f
rm -f $f.old
chmod a+x $f
done

#reduction 
for f in grep rev loadkeys autologinroot cut find; do
add_program /bin/${f}
done

for f in losetup poweroff reboot probepart cddetect_quick guess_fstype; do
cp -f ${SOURCEDIR}/sbin/${f} ${DESTDIR}/sbin/
done

#file							libsize	Where used
#mke2fs /lib/libext2fs.so.2		113K	used in rc.shutdown in busybox-20100217
#mke2fs /lib/libcom_err.so.2	6416B	used in rc.shutdown in	busybox-20100217
#mke2fs /lib/libblkid.so.1		28K		used in rc.shutdown in	busybox-20100217
#mke2fs /lib/libuuid.so.1		8192B	used in rc.shutdown in	busybox-20100217
#mke2fs /lib/libe2p.so.2		16K		used in rc.shutdown in	busybox-20100217
#mkfs.cramfs /lib/libz.so.1		59K		no use in pUPnGO scripts
#tune2fs /lib/libext2fs.so.2	113K	no use in pUPnGO scripts in	busybox-20100217
#tune2fs /lib/libcom_err.so.2	6416B	no use in pUPnGO scripts in	busybox-20100217
#tune2fs /lib/libblkid.so.1		28K		no use in pUPnGO scripts in	busybox-20100217
#tune2fs /lib/libuuid.so.1		8192B	no use in pUPnGO scripts in	busybox-20100217
#tune2fs /lib/libe2p.so.2		16K		no use in pUPnGO scripts in	busybox-20100217
#fsck /lib/libblkid.so.1		28K		no use in pUPnGO scripts in	busybox-20100217
#fsck /lib/libuuid.so.1			8192B	no use in pUPnGO scripts in	busybox-20100217


#BB reduction 19K: fsck -> OK
#remove reduction 14K: mkfs.cramfs -> OK
#remove reduction 20K: tune2fs -> OK
#BB reduction 40K: mke2fs  -> OK
#for f in mke2fs; do
#add_program /sbin/${f}
#done

#programs only using /lib/libc.so.6
#BB reduction 15K: mkfs.minix  -> OK
#BB reduction 4636B: mkfs -> OK	not used in pUPnGO
#BB reduction 4304B: mklost+found -> OK	not used in pUPnGO

for f in losetup-FULL udevd; do
add_program /sbin/${f}
done

#programs not needing libs
#BB reduction 26K: rmmod -> OK
#BB reduction 104K: depmod -> OK
#BB reduction 16K: insmod -> OK
#BB reduction 16K: lsmod -> OK
#BB reduction 600K: e2fsck -> OK
#BB reduction 90K: modprobe.bin ->	used in pup_event_backend_d /needed if udev is present?
for f in elspci; do
add_program /sbin/${f}
done

#NB: fsck.ext2 fsck.ext3 must be symlink to e2fsck
#deactivated fsck.ext2 fsck.ext3
#for f in modprobe; do
#cp -a ${SOURCEDIR}/sbin/${f} ${DESTDIR}/sbin/
#done

fi	#end USE_BB_INT=y


if [ "${USE_BB_INT}" = "n"  ]; then
#/bin related - important programs!
#files in bin - overwrite BB-version
cp -f ${SOURCEDIR}/bin/df ${DESTDIR}/bin/df
cp -f ${SOURCEDIR}/bin/ps ${DESTDIR}/bin/ps		#puppy spec. script
cp -f ${SOURCEDIR}/bin/mount ${DESTDIR}/bin/mount
cp -f ${SOURCEDIR}/bin/cp-FULL ${DESTDIR}/bin/cp-FULL
cp -a ${SOURCEDIR}/sbin/pup* ${DESTDIR}/sbin/

add_program /usr/bin/dialog		#/lib/libncurses.so.5 /lib/libm.so.6
add_program /usr/bin/fuser		#needed for cd.save
add_program /usr/bin/eject		#needed for cd.save 
add_program /usr/bin/wodim		#needed for cd.save
add_program /usr/bin/setfont	#thanks to Keef!
cp -a ${SOURCEDIR}/usr/bin/cdrecord ${DESTDIR}/usr/bin/cdrecord #needed for cd.save symlink to wodim
add_program /usr/bin/dvd+rw-mediainfo	#needed for cd.save


#deactivate below and poweroff fails to save.
for f in ps-FULL mount-FULL dd; do
add_program /bin/${f}
done

#programs only using /lib/libc.so.6
for f in cat sleep cp sed df df-FULL stat grep rev loadkeys autologinroot cut find; do
add_program /bin/${f}
done

for f in losetup poweroff reboot probepart cddetect_quick guess_fstype; do
cp -f ${SOURCEDIR}/sbin/${f} ${DESTDIR}/sbin/
done

for f in fsck tune2fs mkfs.cramfs mke2fs; do
add_program /sbin/${f}
done

#programs only using /lib/libc.so.6
for f in mkfs.minix mkfs mklost+found losetup-FULL udevd; do
add_program /sbin/${f}
done

#programs not needing libs
for f in rmmod depmod insmod lsmod elspci e2fsck modprobe.bin; do
add_program /sbin/${f}
done

#NB: fsck.ext2 fsck.ext3 must be symlink to e2fsck
for f in modprobe fsck.ext2 fsck.ext3; do
cp -a ${SOURCEDIR}/sbin/${f} ${DESTDIR}/sbin/
done

fi #end USE_BB_INT=n


#moved this from top as poweroff first present here
#create /etc/rc.d/rc.local for pUPnGO
create_rc_local	#function call

############NEW ALSA SOUND ETC#############
if [ "${USE_ALSA}" = "y"  ]; then
add_alsa #function call
fi	#end USE_ALSA

if [ "${USE_ENH_GUI}" = "y" ]; then
add_enh_gui #function call
fi

########apps rewritten for dialog only##############################
#message "Adding Modified pfiles..." "--infobox"
#cp -a ${BASEDIR}/data/tools/pupngotools/controlpanel.sh ${DESTDIR}/usr/sbin/controlpanel.sh
#for test of chooselocales
#cp -a ${SOURCEDIR}/usr/lib/locale/ ${DESTDIR}/usr/lib/
#message "Adding putilities..." "--infobox"
#cp -a ${SOURCEDIR}/usr/bin/dir2pet ${DESTDIR}/usr/bin/dir2pet
#cp -a ${SOURCEDIR}/usr/bin/pet2tgz ${DESTDIR}/usr/bin/pet2tgz	#needs /usr/bin/truncate
#add_program /usr/bin/truncate

##########END OF BASIC PUPNGO BUILDING SCELETON SECTION#############
##########USER APPLICATIONS AND ADDS SECTION########################

#Setup and wizards
if [ "${USE_WIZARDS}" = "y"  ]; then
#modified wizards - use with caution....
add_wizards	#function call
fi

#include Xvesa and JWM - GUI-freak "must-have" section...
if [ "${USE_GUI}" = "y"  ]; then
add_xvesa_jwm	#function call
fi

#################kernel modules#############################
#new split to fine tune drivers needed and target build type
#USE_ZDRV: y or n
#DRIVERS: ALL, HOST or USER
##################ZDRV=n####################################
if [ "${USE_ZDRV}" = "n"  ]; then

if [ "${ALL}" = "y" ]; then
#just get all the drivers inside
message "Adding All Kernel Modules..."  "--infobox"
cp -a ${SOURCEDIR}/lib/firmware/ ${DESTDIR}/lib/
cp -a ${SOURCEDIR}/lib/modules/ ${DESTDIR}/lib/
cp -a ${SOURCEDIR}/lib/network/ ${DESTDIR}/lib/
cp -a ${SOURCEDIR}/lib/modules/2.6.25.16/modules* ${DESTDIR}/lib/modules/2.6.25.16/
fi

if [ "${HOST}" = "y" ]; then
message "Adding Host Loaded Kernel Modules..."  "--infobox"
module_finder ${DESTDIR}	#function call
fi

if [ "${USER}" = "y" ]; then
#net drivers for qemu and vmware; modify to your needs...
#added skge for my own test on real hardware...
KERNEL_MODULES="kernel/drivers/net/ne2k-pci.ko kernel/drivers/net/8390.ko kernel/drivers/net/pcnet32.ko kernel/drivers/net/mii.ko kernel/drivers/net/skge.ko"
mkdir -p ${DESTDIR}/lib/modules/${KERNEL_VER}/
message "Adding User Selected Kernel Modules..." "--infobox"
if [ "x${KERNEL_MODULES}" != "x" ]; then
add_kernel_modules ${DESTDIR}
fi
fi

cp -a ${SOURCEDIR}/lib/modules/2.6.25.16/modules* ${DESTDIR}/lib/modules/2.6.25.16/
fi	#end USE_ZDRV=n

##################ZDRV=y#####################################
if [ "${USE_ZDRV}" = "y"  ]; then
if [ -d /tmp/pet ]; then rm -rf /tmp/pet; fi
mkdir -p /tmp/pet/zdrv_412

if [ "${ALL}" = "y" ]; then
message "Adding All Kernel Modules to zdrv_412.sfs..." "--infobox"
#place /lib/firmware, modules and network in zdrv_412.sfs
if [ -d /tmp/pet ]; then rm -rf /tmp/pet; fi
mkdir -p /tmp/pet/zdrv_412/lib
cp -a ${SOURCEDIR}/lib/firmware/ /tmp/pet/zdrv_412/lib/
cp -a ${SOURCEDIR}/lib/modules/ /tmp/pet/zdrv_412/lib/
cp -a ${SOURCEDIR}/lib/network/ /tmp/pet/zdrv_412/lib/
mkdir -p /tmp/pet/zdrv_412/lib/modules/2.6.25.16/
cp -a ${SOURCEDIR}/lib/modules/2.6.25.16/modules* /tmp/pet/zdrv_412/lib/modules/2.6.25.16/
fi

if [ "${HOST}" = "y" ]; then
message "Adding Host Loaded Kernel Modules to zdrv_412.sfs..."  "--infobox"
module_finder /tmp/pet/zdrv_412	#function call
fi

if [ "${USER}" = "y" ]; then
#net drivers for qemu and vmware; modify to your needs...
#added skge for my own test on real hardware...
KERNEL_MODULES="kernel/drivers/net/ne2k-pci.ko kernel/drivers/net/8390.ko kernel/drivers/net/pcnet32.ko kernel/drivers/net/mii.ko kernel/drivers/net/skge.ko"
mkdir -p /tmp/pet/zdrv_412/lib/modules/${KERNEL_VER}/
message "Adding User Selected Kernel Modules to zdrv_412.sfs..." "--infobox"
if [ "x${KERNEL_MODULES}" != "x" ]; then
add_kernel_modules /tmp/pet/zdrv_412	#NB: DESTDIR IS CHANGED PERMANENTLY HERE
fi
fi

DESTDIR=${BASEDIR}/data/P412_SFS/newsfs	#get back on track!
mkdir -p ${DESTDIR}/lib/modules/2.6.25.16/
cp -a ${SOURCEDIR}/lib/modules/2.6.25.16/modules* ${DESTDIR}/lib/modules/2.6.25.16/

fi	#end USE_ZDRV=y

#PET CONVERT AND INSTALL - if .pet file(s) present try to process it/them

#temp build dir
if [ ! -d /tmp/pet/zdrv_412 ]; then
mkdir -p /tmp/pet/zdrv_412/	#always make this - just in case
fi

#check if PET-file(s) present
FILECOUNT=`ls $BASEDIR/data/pets | wc -l`
echo  "${FILECOUNT} file(s) in /data/pets..."		#for debugging
if [ ! $FILECOUNT = "0" ]; then	
cd $BASEDIR/data/pets
PET_FILENAMES=`ls *.pet`
cd $BASEDIR
#echo "PETs found: " $PET_FILENAMES	#for debugging
message "PETs found: ${PET_FILENAMES}" "--msgbox" #for debugging

for d in $PET_FILENAMES; do
echo "Adding and Converting PET..." ${d}
cp -a $BASEDIR/data/pets/${d} /tmp/pet	#copy to /tmp/pet
cd /tmp/pet
pet2tgz ${d}	#unpack pet
tar -zxf ${d/.pet/}.tar.gz
cd $BASEDIR
rm /tmp/pet/${d/.pet/}.tar.gz

#find exe-files and add_program
LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/usr/local/bin/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
	fi
	done
	fi
done

LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/usr/bin/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
		fi
	done
	fi
done

LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/usr/sbin/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
		fi
	done
	fi
done

LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/usr/local/bin/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
		fi
	done
	fi
done

LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/usr/local/sbin/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
		fi
	done
	fi
done

LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/usr/X11R7/bin/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
		fi
	done
	fi
done

LOCALDESTDIR=""
for i in /tmp/pet/${d/.pet/}/vdr/1.6.0/lib/*; do
	if [ -x $i  ];then
	LOCALDESTDIR=/tmp/pet/${d/.pet}
	for LIB in $(ldd ${i} | grep "=>" | cut -d ' ' -f 3); do
	mkdir -p $(dirname ${LOCALDESTDIR}/${LIB})
		if [ ! -f ${LOCALDESTDIR}/${LIB} ]; then	#do not add twice...
		if [ ! -f ${DESTDIR}/${LIB} ]; then	#not in main sfs
		echo "Adding Pet Requested lib..." ${LIB}
		cp ${LIB} ${LOCALDESTDIR}/${LIB}
		fi
		fi
	done
	fi
done

sync

##########pet specific section############
#Lynx Specific:
if [ -f /tmp/pet/${d/.pet/}/usr/local/bin/lynx ]; then
EXTRA_LIBS="libresolv.so.2 libz.so.1"
for LIB in ${EXTRA_LIBS}; do
if [ ! -f /tmp/pet/${d/.pet/}/${LIB} ]; then
#must check if lib is already in pup_412pupngo.sfs
if [ ! -f ${DESTDIR}/lib/${LIB} ]; then
echo "Adding Lynx Specific Lib..." ${LIB}
cp /lib/${LIB} /tmp/pet/${d/.pet/}/lib/${LIB}
fi
fi
done
#add menu to JWM...if ${DESTDIR}/root/.jwmrc present...
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="Lynx Web Browser">rxvt -e /usr/local/bin/lynx</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="Lynx Web Browser">rxvt -e /usr/local/bin/lynx</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
fi
EXTRA_LIBS=""
fi

#Links Specific:
if [ -f /tmp/pet/${d/.pet/}/usr/bin/links ]; then
EXTRA_LIBS="libresolv.so.2 libz.so.1"
for LIB in ${EXTRA_LIBS}; do
if [ ! -f /tmp/pet/${d/.pet/}/${LIB} ]; then
#must check if lib is already in pup_412pupngo.sfs
if [ ! -f ${DESTDIR}/lib/${LIB} ]; then
echo "Adding Links2 Specific Lib..." ${LIB}
cp /lib/${LIB} /tmp/pet/${d/.pet/}/lib/${LIB}
fi
fi
done
#add menu to JWM...if ${DESTDIR}/root/.jwmrc present...
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="Links Web Browser">links -g</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="Links Web Browser">links -g</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
fi
rm /tmp/pet/${d/.pet/}/pinstall.sh
rm /tmp/pet/${d/.pet/}/links.xpm
EXTRA_LIBS=""
fi

#gxine Specific (needs glib-2.14.2.pet, gtk+-2.12.1.pet, gxine-0.5.9-1.pet, xine-lib-1.1.8.pet)
if [ -f /tmp/pet/${d/.pet/}/usr/bin/gxine ]; then
echo "Adding gxine Specific Suff..."
cp -a ${SOURCEDIR}/usr/lib/codecs/ /tmp/pet/${d/.pet/}/usr/lib/
cp -a ${SOURCEDIR}/usr/share/audio/ /tmp/pet/${d/.pet/}/usr/share/
#add menu to JWM...if ${DESTDIR}/root/.jwmrc present...
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="GXine Media Player">rxvt -e /usr/bin/gxine</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="GXine Media Player">gxine</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
#missing wmvdmod.dll
fi



fi

#geany specific (needs glib-2.14.2.pet, gtk+-2.12.1.pet)
if [ -f /tmp/pet/${d/.pet/}/usr/bin/geany ]; then
echo "Adding geany Specific Stuff..."
rm -f /tmp/pet/${d/.pet/}/*.xpm
#add menu to JWM...if ${DESTDIR}/root/.jwmrc present...
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="Geany Text Editor">rxvt -e /usr/bin/geany</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="Geany Text Editor">geany</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
fi
fi

#gparted specific (needs glib-2.14.2.pet, gtk+-2.12.1.pet)
if [ -f /tmp/pet/${d/.pet/}/usr/bin/gparted ]; then
echo "Adding gparted Specific Stuff..."
rm -f /tmp/pet/${d/.pet/}/*.xpm
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="GParted Partition Manager">rxvt -e /usr/bin/gparted</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="GParted Partition Manager">gparted</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
fi
fi


#xfe specific
if [ -f /tmp/pet/${d/.pet/}/usr/bin/xfe ]; then
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="XFE File Manager">xfe</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="XFE File Manager">xfe</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
fi
fi

#abiword specific
if [ -f /tmp/pet/${d/.pet/}/usr/local/bin/abiword ]; then
if [ -f ${DESTDIR}/root/.jwmrc ]; then
#<Program label="Abiword">abiword</Program>
mv ${DESTDIR}/root/.jwmrc ${DESTDIR}/root/.jwmrc.old
sed 's#<Program label="Terminal">rxvt</Program>#<Program label="Terminal">rxvt</Program><Program label="Abiword">abiword</Program>#g' ${DESTDIR}/root/.jwmrc.old > ${DESTDIR}/root/.jwmrc
rm -f ${DESTDIR}/root/.jwmrc.old
fi
fi

#php+mysql specific
if [ -f /tmp/pet/${d/.pet/}/usr/local/bin/mysql ]; then
EXTRA_LIBS="libresolv.so.2 libz.so.1"
for LIB in ${EXTRA_LIBS}; do
if [ ! -f /tmp/pet/${d/.pet/}/${LIB} ]; then
#must check if lib is already in pup_412pupngo.sfs
if [ ! -f ${DESTDIR}/lib/${LIB} ]; then
echo "Adding Hiawatha+php+mysql Specific Lib..." ${LIB}
cp /lib/${LIB} /tmp/pet/${d/.pet/}/lib/${LIB}
fi
fi
done

#move upstart script to /root for first run
mv /tmp/pet/${d/.pet/}/etc/init.d/rc.httpd /tmp/pet/${d/.pet/}/root/rc.httpd
mv /tmp/pet/${d/.pet/}/etc/init.d/rc.mysqld /tmp/pet/${d/.pet/}/root/rc.mysqld
#move postinstall we create our own...do not know why we have to split in 3...anoying!
rm /tmp/pet/${d/.pet/}/pinstall.sh 
mv /tmp/pet/${d/.pet/}/set_root_password_woofwoof.sql /tmp/pet/${d/.pet/}/root/set_root_password_woofwoof.sql
rm /tmp/pet/${d/.pet/}/*.specs
cat >/tmp/pet/${d/.pet/}/root/serversetup.sh <<EOF
#!/bin/sh
chmod 777 /tmp
chmod 777 /dev/null
/usr/local/bin/mysql_install_db --user=nobody --datadir=/usr/local/var
mv /root/rc.mysqld /etc/init.d/rc.mysqld
mv /root/rc.httpd /etc/init.d/rc.httpd
sync
EOF
chmod a+x /tmp/pet/${d/.pet/}/root/serversetup.sh

cat >/tmp/pet/${d/.pet/}/root/startserver.sh <<EOF
#!/bin/sh
/etc/init.d/rc.mysqld start
/etc/init.d/rc.httpd start
EOF
chmod a+x /tmp/pet/${d/.pet/}/root/startserver.sh

cat >/tmp/pet/${d/.pet/}/root/mysqlinstall.sh <<EOF
#!/bin/sh
/usr/local/bin/mysql -u root < /root/set_root_password_woofwoof.sql
#/usr/local/bin/mysqladmin -u root password ´woofwoof´
#/usr/local/bin/mysql -u root SET PASSWORD FOR 'root'@'localhost' = PASSWORD('woofwoof'); &
#/usr/local/bin/mysqladmin -u root -h puppypc password ´woofwoof´
#/usr/local/bin/mysql -u root SET PASSWORD FOR 'root'@'%' = PASSWORD('woofwoof'); &
#/usr/local/bin/mysql -u root DROP USER ''; &
#/usr/local/bin/mysql_secure_installation
EOF
chmod a+x /tmp/pet/${d/.pet/}/root/mysqlinstall.sh

#might be safety risk here...judge yourself...
chmod 777 /tmp/pet/${d/.pet/}/root/httpd/hiawatha/*
mkdir -p /tmp/pet/${d/.pet/}/usr/local/var
cp -a /etc/mime.types /tmp/pet/${d/.pet/}/etc/mime.types
#modify /etc/hiawatha/hiawatha.conf
mv /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf.old
sed 's#\#CGIhandler = /usr/bin/php-cgi:php#CGIhandler = /usr/local/bin/php-cgi:php#g' /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf.old > /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf
mv /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf.old
sed 's#CGIhandler = /usr/bin/perl:pl#\#CGIhandler = /usr/bin/perl:pl#g' /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf.old > /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf
rm -f /tmp/pet/${d/.pet/}/etc/hiawatha/hiawatha.conf.old
fi

#all pet dirs must be collected in /tmp/pet/zdrv_412/
if [ -f /tmp/pet/${d/.pet/}/*.specs ]; then
rm -f /tmp/pet/${d/.pet/}/*.specs	#remove .specs in /tmp/sfs
fi

rm -f /tmp/pet/${d/.pet/}/pinstall.sh

cp -a /tmp/pet/${d/.pet/}/* /tmp/pet/zdrv_412/

done

cd $BASEDIR
if [ -f /tmp/pet/zdrv_412/*.specs ]; then
rm /tmp/pet/zdrv_412/*.specs	#remove .specs in /tmp/sfs
fi

fi  #end check empty pet-directory

if [ "${USE_ZDRV}" = "n"  ]; then
#move any file in /usr/X11R6 to /usr/X11R7
if [ -f /tmp/pet/zdrv_412/usr/X11R6 ]; then
mkdir -p /tmp/pet/zdrv_412/usr/X11R7
cp -a /tmp/pet/zdrv_412/usr/X11R6/* /tmp/pet/zdrv_412/usr/X11R7/
rm -rf /tmp/pet/zdrv_412/usr/X11R6/
cd /tmp/pet/zdrv_412/usr
ln -s X11R7 X11R6
fi
cd ${BASEDIR}
#copy all files to main sfs
if [ -f /tmp/pet/zdrv_412/*.specs ]; then
rm /tmp/pet/zdrv_412/*.specs	#remove .specs in /tmp/sfs
fi

#might give builders a chance to inspect and modify content before creating...
if [ "${USE_DIALOG}" = "y" ]; then
message "You can edit the content before moving the PET content to main build. Enter directory /tmp/pet/zdrv_412/, isnpect and make your changes before pressing OK...." "--msgbox"
fi

#if [ -f /tmp/pet/zdrv_412 ]; then
cp -a /tmp/pet/zdrv_412/* ${DESTDIR}/	
#fi

fi

if [ "${USE_ZDRV}" = "y"  ]; then
#might give builders a chance to inspect and modify content before creating...
if [ "${USE_DIALOG}" = "y" ]; then
message "You can edit the content before moving the PET content to main build. Enter directory /tmp/pet/zdrv_412/, isnpect and make your changes before pressing OK...." "--msgbox"
fi

#pet dir convert to sfs
dir2sfs /tmp/pet/zdrv_412/
#copy new zdrv_412.sfs to $BASEDIR/data/ZDRV
if [ -f $BASEDIR/data/ZDRV/zdrv_412.sfs ]; then
rm $BASEDIR/data/ZDRV/zdrv_412.sfs
fi

mv /tmp/pet/zdrv_412.sfs $BASEDIR/data/ZDRV/zdrv_412.sfs
fi

#end USE_REDUCED=y   BUILD OF PUPNGO
fi

#clean up
if [ -d /tmp/pet ]; then rm -rf /tmp/pet; fi
if [ -d /tmp/unpack ]; then rm -rf /tmp/unpack; fi

######## Create Final ISO Part ########
#build iso with pUPnGO

DESTDIR=${BASEDIR}/data/isomaster
DATADIR=${BASEDIR}/data
OUTPUTDIR=${BASEDIR}/output

################ TAGGING BUILD ###################
#tag $DESTDIR/boot.msg

cat > $DESTDIR/boot.msg <<EOF

EOF
echo "0bpUPnGO_V"$VERSION"_Build"$BUILD "Custum Puppy Based On P412" >> $DESTDIR/boot.msg
cat >> $DESTDIR/boot.msg <<EOF
0a
Just wait 5 seconds for normal startup!
07
Or, if you need particular boot options, type0c puppy07 then a space,
then each boot option. Some boot options:

0cacpi=off07     Default on for PCs >2001, may give boot/shutdown probs.
0cloglevel=<n>07 Bootup verbosity. 7 is high verbosity for debugging.
0cpfix=ram07     Run totally in RAM ignore saved sessions,
0cpfix=<n>07     number of saved sessions to ignore (multisession-CD),
0cpfix=nox07     commandline only, do not start X,
0cpfix=copy07    copy DISTRO_FILE_PREFIXrxxx.sfs to RAM (slower boot, faster running),
0cpfix=fsck07    do filesystem check on DISTRO_FILE_PREFIXsave (and host part. if ext2),
0cpfix=clean07   file cleanup (simulate version upgrade),
0cpfix=purge07   more radical file cleanup (to fix broken system),
pfix=rdsh    for developers only (initramfs shell).

Examples: 
0cpuppy acpi=off pfix=207    Ignore ACPI, blacklist last 2 saved sessions.
0cpuppy pfix=nox,ram07       Run in RAM, do not start X.



EOF

######## delete old project files ########
#echo "Deleting old files..."
message "Deleting Old Files..." "--infobox"

#DESTDIR CLEAN
if [ -f $DESTDIR/initrd.gz ]; then rm -r $DESTDIR/initrd.gz; fi
if [ -f $DESTDIR/pup_412pUPnGO.sfs ]; then rm -r $DESTDIR/pup_412pUPnGO.sfs; fi
if [ -f $DESTDIR/isolinux.cfg ]; then rm -r $DESTDIR/isolinux.cfg; fi
if [ -f $DESTDIR/zdrv_412.sfs ]; then rm -r $DESTDIR/zdrv_412.sfs; fi
#DATADIR CLEAN
if [ -f $DATADIR/P412_initrd/build/initrd.gz ]; then rm -r $DATADIR/P412_initrd/build/initrd.gz; fi
if [ -f $DATADIR/P412_SFS/build/pup_412pUPnGO.sfs ]; then rm -r $DATADIR/P412_SFS/build/pup_412pUPnGO.sfs; fi


######## create files ########
#echo "Creating new P412_SFS..."
message "Creating New P412_SFS..." "--infobox"

if [ ${BUILDTYPE} = "DEV" ]; then
TAG=`echo $RANDOM`
mksquashfs ${DATADIR}/P412_SFS/newsfs ${DATADIR}/P412_SFS/build/pup_412${TAG}.sfs -noappend
else
mksquashfs ${DATADIR}/P412_SFS/newsfs ${DATADIR}/P412_SFS/build/pup_412pUPnGO.sfs -noappend
fi

######## copy files ########
#echo "Copying files to iso..."
message "Copying Files to iso..." "--infobox"

#documentation - copy build script to doc
for d in doc tools/busybox tools/grub tools/bootmanager; do
if [ ! -d ${DESTDIR}/${d} ]; then
mkdir -p ${DESTDIR}/${d}
fi
done

cp ${BASEDIR}/build_pupngo_412.sh ${DESTDIR}/doc/build_pupngo_412.sh

if [ -f ${BASEDIR}/data/tools/busybox/busybox ]; then
cp -f ${BASEDIR}/data/tools/busybox/busybox ${DESTDIR}/tools/busybox/busybox 
fi

if [ -f ${BASEDIR}/data/tools/grub/new_grubconfig ]; then
cp -f ${BASEDIR}/data/tools/grub/new_grubconfig ${DESTDIR}/tools/grub/new_grubconfig
fi

if [ -f ${BASEDIR}/data/tools/bootmanager/new_bootmanager ]; then
cp -f ${BASEDIR}/data/tools/bootmanager/new_bootmanager ${DESTDIR}/tools/bootmanager/new_bootmanager
fi

cp ${DATADIR}/P412_initrd/packed/initrd.gz ${DESTDIR}/initrd.gz
if [ ${BUILDTYPE} = "DEV" ]; then
cp ${DATADIR}/P412_SFS/build/pup_412${TAG}.sfs ${DESTDIR}/pup_412${TAG}.sfs
else
cp ${DATADIR}/P412_SFS/build/pup_412pUPnGO.sfs ${DESTDIR}/pup_412pUPnGO.sfs
fi

if [ "${USE_ZDRV}" = "y"  ]; then
if [ -f ${DATADIR}/ZDRV/zdrv_412.sfs ]; then
cp ${DATADIR}/ZDRV/zdrv_412.sfs ${DESTDIR}/zdrv_412.sfs
fi
fi

######## create isolinux.cfg ########
cat >${DESTDIR}/isolinux.cfg <<EOF
DEFAULT puppy
DISPLAY boot.msg
PROMPT 1
LABEL puppy
KERNEL vmlinuz
APPEND initrd=initrd.gz pmedia=cd
TIMEOUT 50
EOF

######## create iso ########
#echo "Creating Bootable pUPnGO iso..."
message "Creating Bootable pUPnGO iso..." "--infobox"

mkisofs -o ${OUTPUTDIR}/output.iso -jcharset iso-8859-1 -R -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table ${DATADIR}/isomaster

#Make release version
if [ "${USE_GUI}" = "y"  ]; then
cp -f ${BASEDIR}/output/output.iso /${BASEDIR}/output/pUPnGO_V412_XVESA_JWM.iso
else
cp -f ${BASEDIR}/output/output.iso /${BASEDIR}/output/pUPnGO_V412.iso
fi

#USB build must come here...
if [ "${USB}" = "y" ]; then
message "USB is not implemented as an automatic build - to risky. Its is easy to make the USB-version: Create a USB-version with original P412 and test if it boots ok. After that you just transfer pUPnGO main sfs-file and zdrv to the USB stick and delete the original pup_412.sfs file..." "--msgbox"
fi


######## all set and done ########
#echo "Finished...."
USE_DIALOG=y	#otherwise no indication that all is done if no menu chosen...
message "Finished...." "--msgbox"
exit